import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private public def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public public def run() as int:
		for i in range(iterations):
			self.runullIteration()
		return self.microSeconds
		
	public virtual public def runullIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public public def constructor(iterations as int):
		self.iterations = iterations
		
	public public def runullIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = JGFRayTracerBench()		
		chronometer.start()
		test.Test()		
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Vec:
	public x as duck
	public y as duck
	public z as duck
	public def constructor():		
		self.x = 0.0
		self.y = 0.0
		self.z = 0.0
		
	public def constructor(a as duck,b as duck,c as duck):		
		self.x = a
		self.y = b
		self.z = c
	
	public def add1(a as duck):
		self.x = a.x + self.x
		self.y = a.y + self.y
		self.z = a.z + self.z
	
	public static def adds(s as duck,a as duck,b as duck) as duck:	
		return Vec(s * a.x + b.x, s * a.y + b.y, s * a.z + b.z)	

	public def adds(s as duck,b as duck):	
		self.x = self.x + (s * b.x)
		self.y = self.y + (s * b.y)
		self.z = self.z + (s * b.z)

	public static def sub1(a as duck,b as duck) as duck:		
		return Vec(a.x - b.x, a.y - b.y, a.z - b.z)
	
	public def sub2(a as duck,b as duck):
		self.x = a.x - b.x
		self.y = a.y - b.y
		self.z = a.z - b.z	
	
	public static def mult1(a as duck,b as duck) as duck:
		return Vec(a.x * b.x, a.y * b.y, a.z * b.z)

	public static def cross(a as duck,b as duck) as duck:
		return Vec(a.y * b.z - a.z * b.y, a.z * b.x - a.x * b.z, a.x * b.y - a.y * b.x)
	
	public static def dot(a as duck,b as duck) as duck:
		return a.x * b.x + a.y * b.y + a.z * b.z
	
	public static def comb(a as duck,A as duck,b as duck,B as duck) as duck:
		return Vec(a * A.x + b * B.x, a * A.y + b * B.y, a * A.z + b * B.z)
	
	public def comb2(a as duck,A as duck,b as duck,B as duck):
		self.x = a * A.x + b * B.x
		self.y = a * A.y + b * B.y
		self.z = a * A.z + b * B.z	

	public def scale(t as duck):
		self.x = t * self.x
		self.y = t * self.y
		self.z = t * self.z
	
	public def negate():
		self.x = -1.0 * self.x
		self.y = -1.0 * self.y
		self.z = -1.0 * self.z
	
	public def normalize() as duck:
		length as duck
		length = Math.Sqrt(self.x * self.x + self.y * self.y + self.z * self.z)
		while length > 0.0:
			self.x = self.x / length
			self.y = self.y / length
			self.z = self.z / length
			length = 0.0			
		return length
		
	public override def ToString() as string:
		return "<" + self.x.ToString() + "," + self.y.ToString() + "," + self.z.ToString() + ">"

class View:
	public fromVec as duck
	public atVec as duck
	public upVec as duck
	public dist as duck
	public angle as duck
	public aspect as duck
	
	public def constructor(fromVec as duck,atVec as duck,upVec as duck,dist as duck,angle as duck,aspect as duck):
		self.fromVec = fromVec
		self.atVec = atVec
		self.upVec = upVec
		self.dist = dist
		self.angle = angle
		self.aspect = aspect

class Ray:	
	public P as duck
	public D as duck
	
	public def constructor():
		self.P = Vec()			
		self.D = Vec()			
		
	public def constructor(pnt as duck,dir as duck):
		self.P = Vec()			
		self.P.add1(pnt)
		self.D = Vec()			
		self.D.add1(dir)
		self.D.normalize()

	public def point(t as duck) as duck:
		return Vec(self.P.x + self.D.x * t, self.P.y + self.D.y * t, self.P.z + self.D.z * t)
	
	public override def ToString() as string:	
		return "" + self.P.ToString() + " -> " + self.P.ToString() + ""

class Interval:	
	public number as duck
	public width as duck
	public height as duck
	public yfrom as duck
	public yto as duck
	public total as duck
		
	public def constructor(number as duck,width as duck,height as duck,yfrom as duck,yto as duck,total as duck):
		self.number = number
		self.width = width
		self.height = height
		self.yfrom = yfrom
		self.yto = yto
		self.total = total
	
class Isect:
	public t as duck
	public enter as duck
	public prim as duck
	public surf as duck	
	
	public def constructor():
		self.t = null
		self.enter = null
		self.prim = null
		self.surf = null
		
	public override def ToString() as string:
		return "" + self.t.ToString() + "," + self.enter.ToString() + "," + self.prim.ToString() + "," + self.surf.ToString() + ""
		
class Light:
	public pos as duck
	public brightness as duck
		
	public def constructor():
		self.pos = null
		self.brightness = null
		
	public def constructor(x as duck,y as duck,z as duck,brightness as duck):
		self.pos = Vec(x,y,z)		
		self.brightness = brightness
		
class Surface:
	public color as duck
	public kd as duck 
	public ks as duck 
	public shine as duck 
	public kt as duck 
	public ior as duck
		
	public def constructor():
		self.color = Vec(1.0, 0.0, 0.0)
		self.kd = 1.0
		self.ks = 0.0
		self.shine = 0.0
		self.kt = 0.0
		self.ior = 1.0

	public override def ToString() as string:
		return "Surface  color=" + color.ToString() + ""

class Primitive:
	public surf as duck
	
	public def constructor():
		self.surf = Surface()

	public def setColor(r as duck,g as duck,b as duck):
		self.surf.color = Vec(r, g, b)
		
class Sphere(Primitive):
	public c as duck
	public r as duck
	public r2 as duck
	public v as duck
	public b as duck
		
	public def constructor(center as duck,radius as duck):		
		self.c = center
		self.r = radius
		self.r2 = radius * radius
		self.v = Vec()
		self.b = Vec()
	
	public def intersect(ry as duck) as duck:
		p as duck	
		p = ry.P
		d as duck		
		d = ry.D	   			
		self.v.sub2(self.c, p)		
		b as duck
		b = Vec.dot(self.v, d)
		dotVV as duck
		dotVV = Vec.dot(self.v, self.v)
		disc as duck
		disc = b * b - dotVV + self.r2				
		if disc < 0.0:
			return null														
		disc = Math.Sqrt(disc)
		t as duck
		t = (b + disc if (b - disc) < 0.000001 else b - disc)
		if t < 0.000001:
			return null
		ip as duck
		ip = Isect()
		ip.t = t						
		ip.enter = (1.0 if dotVV > (self.r2 + 0.000001) else 0.0)
		ip.prim = self
		ip.surf = self.surf
		return ip			
	
	public def normal(p as duck) as duck:
		r as duck
		r = Vec.sub1(p, self.c)
		r.normalize()
		return r	

	public def getCenter() as duck:
		return self.c
		
	public def setCenter(c as duck):
		self.c = c

	public override def ToString() as string:
		return "Sphere " + self.c.ToString() + "," + self.r.ToString() + ""
		
class Scene:
	public lights as duck
	public objects as duck
	public view as duck 
	public def constructor():
		self.lights = []
		self.objects = []
		self.view = null

	public def addLight(l as duck):
		self.lights.Add(l)
	
	public def addObject(myobject as duck):
		self.objects.Add(myobject)
	
	public def setView(view as duck):	
		self.view = view
	
	public def getView() as duck:
		return self.view
	
	public def getLight(number as duck) as duck:
		return self.lights[number]
	
	public def getObject(number as duck) as duck:
		return self.objects[number]	

	public def getLights() as duck:
		return len(self.lights)

	public def getObjects() as duck:
		return len(self.objects)
	
	public def setObject(myobject as duck,pos as duck):
		self.objects[pos] = myobject
		
class RayTracer:	
	public static alpha as duck
	public static voidVec as duck
	public datasizes as duck
	public tRay as duck
	public L as duck
	public inter as duck
	public checksum as duck
	public size as duck
	public numobjects as duck
	public height as duck
	public width as duck
	public view as duck
	public prim as duck
	public lights as duck
	public scene as duck
	
	public def constructor():
		self.datasizes = []
		self.datasizes.Add(5)
		self.datasizes.Add(10)
		self.datasizes.Add(15)
		self.datasizes.Add(20)
		self.datasizes.Add(25)
		self.datasizes.Add(30)
		self.datasizes.Add(35)
		self.datasizes.Add(40)
		self.datasizes.Add(45)
		self.datasizes.Add(50)
		RayTracer.alpha = 255 << 24
		self.tRay = Ray()
		RayTracer.voidVec = Vec()
		self.L = Vec()
		self.inter = Isect()
		self.checksum = 0
		
		self.size = null
		self.numobjects = null
		self.height = null
		self.width = null
		self.view = null
		self.prim = null
		self.lights = null
		self.scene = null

	public def createScene() as duck:
		x as duck
		x = 0.0
		y as duck
		y = 0.0
		scene as duck
		scene = Scene()
		nx as duck
		nx = 4.0
		ny as duck
		ny = 4.0
		nz as duck
		nz = 4.0
		i as duck
		i = 0.0			
		while i < nx:		
			j as duck
			j = 0.0
			while j < ny:			
				k as duck
				k = 0.0
				while k < nz:				
					xx as duck
					xx = 20.0 / (nx - 1.0) * i - 10.0
					yy as duck
					yy = 20.0 / (ny - 1.0) * j - 10.0
					zz as duck
					zz = 20.0 / (nz - 1.0) * k - 10.0												
					p as duck
					p = Sphere(Vec(xx, yy, zz), 3.0)					
					p.setColor(0.0, 0.0, (i + j) / (nx + ny - 2.0))					
					p.surf.shine = 15.0
					p.surf.ks = 1.5 - 1.0
					p.surf.kt = 1.5 - 1.0						
					scene.addObject(p)						
					k = k + 1.0				
				j = j + 1.0			
			i = i + 1.0		

		scene.addLight(Light(100.0, 100.0, -50.0, 1.0))
		scene.addLight(Light(-100.0, 100.0, -50.0, 1.0))
		scene.addLight(Light(100.0, -100.0, -50.0, 1.0))
		scene.addLight(Light(-100.0, -100.0, -50.0, 1.0))
		scene.addLight(Light(200.0, 200.0, 0.0, 1.0))
		v as duck
		v = View(Vec(x, 20.0, -30.0), Vec(x, y, 0.0), Vec(0.0, 1.0, 0.0), 1.0, 35.0 * 3.14159265 / 180.0, 1.0)
		scene.setView(v)
		return scene

	public def setScene(scene as duck):		
		nLights as duck
		nLights = scene.getLights()
		nObjects as duck
		nObjects = scene.getObjects()		
		self.lights = array(Light,nLights cast int)		
		self.prim = array(Primitive,nObjects cast int)
		l as duck
		l = 0
		while l < nLights:
			self.lights[l] = scene.getLight(l)
			l = l + 1		
		o as duck
		o = 0
		while o < nObjects:		
			self.prim[o] = scene.getObject(o)
			o = o + 1		
		self.view = scene.getView()

	public def intersect(r as duck,tmax as duck) as duck:		
		nhits as duck
		nhits = 0
		temp as duck
		temp =  Isect()			
		temp.t = 1e9	
		self.inter = temp					
		i as duck
		i = 0											
		while i < len(self.prim):
			tp as duck
			tp = self.prim[i].intersect(r)
			sw as duck
			sw = (tp != null)					
			if(sw == true):
				isect as duck
				isect = Isect()							
				isect.t = tp.t															
				isect.prim = tp.prim
				isect.surf = tp.surf
				isect.enter = tp.enter														
				self.inter = isect							
				nhits = nhits + 1											
			i = i + 1
		return (true if nhits > 0 else false)
		
	public def trace(level as duck,weight as duck,r as duck) as duck:
		if level > 6:
			return Vec()
		hit as duck
		hit = self.intersect(r, 1e6)
		if hit == true:
			P as duck
			P = r.point(self.inter.t)
			N as duck
			N = self.inter.prim.normal(P)
			if Vec.dot(r.D, N) >= 0.0:
				N.negate()
			#return shade(level, weight, P, N, r.D, inter)	
		return voidVec
		
	public def SpecularDirection(I as duck,N as duck) as duck:
		dotIN as duck
		dotIN = Vec.dot(I, N)
		abs as duck
		abs =  (dotIN if dotIN > 0 else -1 * dotIN)
		r as duck
		r = Vec.comb(1.0 / abs, I, 2.0, N)
		r.normalize()
		return r
		
	public def TransDir(m1 as duck,m2 as duck,I as duck,N as duck) as duck:
		n1 as duck		
		n1 = (1.0 if m1 == null else m1.ior)
		n2 as duck
		n2 = (1.0 if m2 == null else m2.ior)
		eta as duck
		eta = n1 / n2
		c1 as duck
		c1 = -1 * Vec.dot(I, N)
		cs2 as duck
		cs2 = 1.0 - eta * eta * (1.0 - c1 * c1)
		if cs2 < 0.0:
			return null
		r as duck
		r = Vec.comb(eta, I, eta * c1 - Math.Sqrt(cs2), N)
		r.normalize()
		return r

	public def Shadow(r as duck,tmax as duck) as duck:
		if intersect(r,tmax) == true:
			return 0
		return 1

	public def render(interval as duck):
		localView as duck
		localView = self.view			
		viewVec as duck
		viewVec = Vec.sub1(localView.atVec, localView.fromVec)											
		viewVec.normalize()			
		tmpVec as duck
		tmpVec = Vec(viewVec.x, viewVec.y, viewVec.z)			
		dotValue as duck
		dotValue = Vec.dot(localView.upVec, viewVec)			
		tmpVec.scale(dotValue)			
		upVec as duck
		upVec = Vec.sub1(localView.upVec, tmpVec)
		upVec.normalize()
		leftVec as duck
		leftVec = Vec.cross(localView.upVec, viewVec)
		leftVec.normalize()		
		frustrumwidth as duck
		frustrumwidth = localView.dist * Math.Tan(localView.angle)						
		upVec.scale(-frustrumwidth)			
		scaleValue as duck
		scaleValue = localView.aspect * frustrumwidth
		leftVec.scale(scaleValue)						
		r as duck
		r = Ray(localView.fromVec, RayTracer.voidVec)
		y as duck
		y = interval.yfrom					
		nhits as duck
		nhits = 0					
		while y < interval.yto:
			ylen as duck
			ylen = (2.0 * y) / interval.width - 1.0
			x as duck
			x = 0
			while x < interval.width:
				xlen as duck
				xlen = (2.0 * x) / interval.width - 1.0					
				r.D = Vec.comb(xlen, leftVec, ylen, upVec)	 					
				r.D.add1(viewVec) 									
				r.D.normalize()																
				hit as duck
				hit = self.intersect(r, 1e6)										
				if hit == true:
					nhits = nhits + 1
				x = x + 1			
			y = y + 1		
		self.checksum = self.checksum + nhits		

class JGFRayTracerBench(RayTracer):
	public def JGFsetsize(size as duck):
		self.size = size
		
	public def JGFinitialise():		
		self.height = self.datasizes[self.size]
		self.width = self.height
		self.scene = self.createScene()
		self.setScene(self.scene)
		self.numobjects = self.scene.getObjects()
		
	public def JGFapplication():
		interval = Interval(0, self.width, self.height, 0, self.height, 1)
		self.render(interval)		

	public def JGFvalidate():		
		refval =  array(int, 10)
		refval[0] = 12
		refval[1] = 40			
		refval[2] = 104			
		refval[3] = 170	 
		refval[4] = 278			
		refval[5] = 390
		refval[6] = 552			
		refval[7] = 692			
		refval[8] = 894	 
		refval[9] = 1084			
		dev = self.checksum - refval[self.size]
		if dev != 0:			
			print "Validation failed"
			print "Pixel checksum = " + self.checksum.ToString()
			print "Reference value = " + (refval[self.size])
			
	public def Test():
		self.JGFsetsize(4)
		self.JGFinitialise()
		self.JGFapplication()
		self.JGFvalidate()			
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()