import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()			
		test = SimpleIntFloatArithmetic()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class SimpleIntFloatArithmetic(Test):
	def test():		
		a as duck
		b as duck
		c as duck
		a = 2
		b = 3
		c = 3.14159
		for i in range(120000):
			c = a + b
			c = b + c
			c = c + a
			c = a + b
			c = b + c

			c = c - a
			c = a - b
			c = b - c
			c = c - a
			c = b - c

			c = a / b
			c = b / a
			c = c / b

			c = a * b
			c = b * a
			c = c * b

			c = a / b
			c = b / a
			c = c / b

			a = 2
			b = 3
			c = 3.14159

			c = a + b
			c = b + c
			c = c + a
			c = a + b
			c = b + c

			c = c - a
			c = a - b
			c = b - c
			c = c - a
			c = b - c

			c = a / b
			c = b / a
			c = c / b

			c = a * b
			c = b * a
			c = c * b

			c = a / b
			c = b / a
			c = c / b

			a = 2
			b = 3
			c = 3.14159

			c = a + b
			c = b + c
			c = c + a
			c = a + b
			c = b + c

			c = c - a
			c = a - b
			c = b - c
			c = c - a
			c = b - c

			c = a / b
			c = b / a
			c = c / b

			c = a * b
			c = b * a
			c = c * b

			c = a / b
			c = b / a
			c = c / b

			a = 2
			b = 3
			c = 3.14159

			c = a + b
			c = b + c
			c = c + a
			c = a + b
			c = b + c

			c = c - a
			c = a - b
			c = b - c
			c = c - a
			c = b - c

			c = a / b
			c = b / a
			c = c / b

			c = a * b
			c = b * a
			c = c * b

			c = a / b
			c = b / a
			c = c / b

			a = 2
			b = 3
			c = 3.14159

			c = a + b
			c = b + c
			c = c + a
			c = a + b
			c = b + c

			c = c - a
			c = a - b
			c = b - c
			c = c - a
			c = b - c

			c = a / b
			c = b / a
			c = c / b

			c = a * b
			c = b * a
			c = c * b

			c = a / b
			c = b / a
			c = c / b
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()