import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = MethodCalls()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class c:
	y as duck
	t as duck
	x as duck
	s as duck	
	
	public def constructor():
		self.x = 2
		self.s = 'string'
		
	def f() as duck:
		return self.x

	def j(a as duck,b as duck) as duck:
		self.y = a
		self.t = b
		return self.y

	def k(a as duck,b as duck,c as duck):
		self.y = a
		self.s = b.ToString()
		self.t = c

class MethodCalls(Test):
	public def test():	
		o as duck
		two as duck
		three as duck
		four as duck
		o = c()
		two = 2
		three = 3
		four = 4
		for i in range(30000):
			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.j(i,i)
			o.j(i,i)
			o.j(i,two)
			o.j(i,two)
			o.j(two,two)
			o.k(i,i,three)
			o.k(i,two,three)
			o.k(i,two,three)
			o.k(i,i,four)

			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.j(i,i)
			o.j(i,i)
			o.j(i,two)
			o.j(i,two)
			o.j(two,two)
			o.k(i,i,three)
			o.k(i,two,three)
			o.k(i,two,three)
			o.k(i,i,four)

			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.j(i,i)
			o.j(i,i)
			o.j(i,two)
			o.j(i,two)
			o.j(two,two)
			o.k(i,i,three)
			o.k(i,two,three)
			o.k(i,two,three)
			o.k(i,i,four)

			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.j(i,i)
			o.j(i,i)
			o.j(i,two)
			o.j(i,two)
			o.j(two,two)
			o.k(i,i,three)
			o.k(i,two,three)
			o.k(i,two,three)
			o.k(i,i,four)

			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.f()
			o.j(i,i)
			o.j(i,i)
			o.j(i,two)
			o.j(i,two)
			o.j(two,two)
			o.k(i,i,three)
			o.k(i,two,three)
			o.k(i,two,three)
			o.k(i,i,four)
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()