import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = IfThenElse()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class IfThenElse(Test):
	def test():
		one as duck
		two as duck
		three as duck
		a as duck
		b as duck
		c as duck
		one,two,three = 1,2,3
		a,b,c = one,two,three
		for i in range(150000 * 3):
			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1

			if a == 1:
				if b == 2:
					if c != 3:
						c = 3
						b = 3
					else:
						c = 2
				elif b == 3:
					b = 2
					a = 2
			elif a == 2:
				a = 3
			else:
				a = 1
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()