import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = DictWithFloatKeys()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class DictWithFloatKeys(Test):
	def test():
		one as duck
		two as duck
		three as duck
		four as duck
		five as duck
		six as duck
		d as duck
				
		one = 1
		two = 2
		three = 3
		four = 4
		five = 5
		six = 6
		d = {}

		for i in range(150000):
			d[1.234] = one
			d[2.345] = two
			d[3.456] = three
			d[4.567] = four
			d[5.678] = five
			d[6.789] = six

			temp = d[1.234]
			temp = d[2.345]
			temp = d[3.456]
			temp = d[4.567]
			temp = d[5.678]
			temp = d[6.789]

			d[1.234] = one
			d[2.345] = two
			d[3.456] = three
			d[4.567] = four
			d[5.678] = five
			d[6.789] = six

			temp = d[1.234]
			temp = d[2.345]
			temp = d[3.456]
			temp = d[4.567]
			temp = d[5.678]
			temp = d[6.789]

			d[1.234] = one
			d[2.345] = two
			d[3.456] = three
			d[4.567] = four
			d[5.678] = five
			d[6.789] = six

			temp = d[1.234]
			temp = d[2.345]
			temp = d[3.456]
			temp = d[4.567]
			temp = d[5.678]
			temp = d[6.789]

			d[1.234] = one
			d[2.345] = two
			d[3.456] = three
			d[4.567] = four
			d[5.678] = five
			d[6.789] = six

			temp = d[1.234]
			temp = d[2.345]
			temp = d[3.456]
			temp = d[4.567]
			temp = d[5.678]
			temp = d[6.789]

			d[1.234] = one
			d[2.345] = two
			d[3.456] = three
			d[4.567] = four
			d[5.678] = five
			d[6.789] = six

			temp = d[1.234]
			temp = d[2.345]
			temp = d[3.456]
			temp = d[4.567]
			temp = d[5.678]
			temp = d[6.789]

		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()