import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = SimpleDictManipulation()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class SimpleDictManipulation(Test):
	def HasKey(d as duck, key as duck) as duck:
		if key >= d.Count:
			return false
		return d[key] != 0

	def test():
		zero as duck
		one as duck
		two as duck
		three as duck
		four as duck
		five as duck
		six as duck
		eight as duck
		ten as duck
		d as duck
		
		zero = 0
		one = 1
		two = 2
		three = 3
		four = 4
		five = 5
		six = 6
		eight = 8
		ten = 10
		d = {}		

		for i in range(100000):
			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			HasKey(d,zero)
			HasKey(d,two)
			HasKey(d,four)
			HasKey(d,six)
			HasKey(d,eight)
			HasKey(d,ten)

			d[0] = zero
			d[1] = zero
			d[2] = zero
			d[3] = zero
			d[4] = zero
			d[5] = zero

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			HasKey(d,zero)
			HasKey(d,two)
			HasKey(d,four)
			HasKey(d,six)
			HasKey(d,eight)
			HasKey(d,ten)

			d[0] = zero
			d[1] = zero
			d[2] = zero
			d[3] = zero
			d[4] = zero
			d[5] = zero

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			HasKey(d,zero)
			HasKey(d,two)
			HasKey(d,four)
			HasKey(d,six)
			HasKey(d,eight)
			HasKey(d,ten)

			d[0] = zero
			d[1] = zero
			d[2] = zero
			d[3] = zero
			d[4] = zero
			d[5] = zero

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			HasKey(d,zero)
			HasKey(d,two)
			HasKey(d,four)
			HasKey(d,six)
			HasKey(d,eight)
			HasKey(d,ten)

			d[0] = zero
			d[1] = zero
			d[2] = zero
			d[3] = zero
			d[4] = zero
			d[5] = zero

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			HasKey(d,zero)
			HasKey(d,two)
			HasKey(d,four)
			HasKey(d,six)
			HasKey(d,eight)
			HasKey(d,ten)

			d[0] = zero
			d[1] = zero
			d[2] = zero
			d[3] = zero
			d[4] = zero
			d[5] = zero
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()