import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = SimpleListManipulation()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class SimpleListManipulation(Test):
	def test():
		l as duck
		l = []	

		one as duck
		two as duck
		three as duck
		four as duck
		five as duck
				
		one = 1
		two = 2
		three = 3
		four = 4
		five = 5
		
		x as duck
					
		for i in range(130000):
			l.Add(two)
			l.Add(three)
			l.Add(four)
			l.Add(two)
			l.Add(three)
			l.Add(four)

			l[0] = three
			l[1] = four
			l[2] = five
			l[3] = three
			l[4] = four
			l[5] = five

			x = l[0]
			x = l[1]
			x = l[2]
			x = l[3]
			x = l[4]
			x = l[5]

			l.Add(two)
			l.Add(three)
			l.Add(four)
			l.Add(two)
			l.Add(three)
			l.Add(four)

			l[0] = three
			l[1] = four
			l[2] = five
			l[3] = three
			l[4] = four
			l[5] = five

			x = l[0]
			x = l[1]
			x = l[2]
			x = l[3]
			x = l[4]
			x = l[5]

			l.Add(two)
			l.Add(three)
			l.Add(four)
			l.Add(two)
			l.Add(three)
			l.Add(four)

			l[0] = three
			l[1] = four
			l[2] = five
			l[3] = three
			l[4] = four
			l[5] = five

			x = l[0]
			x = l[1]
			x = l[2]
			x = l[3]
			x = l[4]
			x = l[5]

			l.Add(two)
			l.Add(three)
			l.Add(four)
			l.Add(two)
			l.Add(three)
			l.Add(four)

			l[0] = three
			l[1] = four
			l[2] = five
			l[3] = three
			l[4] = four
			l[5] = five

			x = l[0]
			x = l[1]
			x = l[2]
			x = l[3]
			x = l[4]
			x = l[5]

			l.Add(two)
			l.Add(three)
			l.Add(four)
			l.Add(two)
			l.Add(three)
			l.Add(four)

			l[0] = three
			l[1] = four
			l[2] = five
			l[3] = three
			l[4] = four
			l[5] = five

			x = l[0]
			x = l[1]
			x = l[2]
			x = l[3]
			x = l[4]
			x = l[5]

			if len(l) > 10000:
				# cut down the size
				l.Clear()
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()