import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = CreateNewInstances()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class Root:            
	a as duck
	public def constructor(a as duck):
		self.a = a
		
	public def constructor():
		self.a = null
		
class c(Root):
	public def constructor():
		super()
	
class d(Root):	
	b as duck
	c as duck	
	public def constructor(a as duck,b as duck,c as duck):
		super(a)
		self.b = b
		self.c = c

class e(Root):	
	b as duck
	c as duck
	d as duck
	e as duck	
	f as duck	
	public def constructor(a as duck,b as duck,c as duck):	
		super(a)
		self.b = b
		self.c = c
		self.d = a
		self.e = b
		self.f = c
	
class CreateNewInstances(Test):
	def test():
		three as duck
		four as duck
		i as duck
		three = 3
		four = 4
		i = 0
		while i < 800000:
			o as duck
			o = c()
			o1 as duck
			o1 = c()
			o2 as duck
			o2 = c()
			p as duck
			p = d(i,i,three)
			p1 as duck
			p1 = d(i,i,three)
			p2 as duck
			p2 = d(i,three,three)
			p3 as duck
			p3 = d(three,i,three)
			p4 as duck
			p4 = d(i,i,i)
			p5 as duck
			p5 = d(three,i,three)
			p6 as duck
			p6 = d(i,i,i)
			q as duck
			q = e(i,i,three)
			q1 as duck
			q1 = e(i,i,three)
			q2 as duck
			q2 = e(i,i,three)
			q3 as duck
			q3 = e(i,i,four)					
			i = i + 1
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()