import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = StringMappings()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class StringMappings(Test):
	def test():
		s as duck
		t as duck
		u as duck
		v as duck
		b as duck
		s = ""
		t = ""
		u = ""
		v = ""
		for i in range(20):
			s += "" + i
		for i in range(50):
			t += "" + i	
		for i in range(100):
			u += "" + i
		for i in range(256):
			v += "" + i				
		
		for i in range(70000):
			b = s.ToLower()
			b = s.ToLower()
			b = s.ToLower()
			b = s.ToLower()
			b = s.ToLower()

			b = s.ToUpper()
			b = s.ToUpper()
			b = s.ToUpper()
			b = s.ToUpper()
			b = s.ToUpper()

			b = t.ToLower()
			b = t.ToLower()
			b = t.ToLower()
			b = t.ToLower()

			b = t.ToUpper()
			b = t.ToUpper()
			b = t.ToUpper()
			b = t.ToUpper()

			b = u.ToLower()
			b = u.ToLower()

			b = u.ToUpper()
			b = u.ToUpper()

			b = v.ToLower()

			b = v.ToUpper()
			
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()