import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = StringSlicing()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class StringSlicing(Test):
	def test():
		s as duck	
		s = ""
		for i in range(100):
			s += "" + i
		
		zero as duck
		one as duck
		two as duck
		five as duck
		eleven as duck
		twentyfive as duck
		fifty as duck
		fiftyfive as duck
		
		zero = 0
		one = 1
		two = 2
		five = 5
		eleven = 11
		twentyfive = 25
		fifty = 50
		fiftyfive = 55
		
		b as duck		
		for i in range(160000):
			b = s.Substring(fifty,s.Length - fifty)
			b = s.Substring(zero,twentyfive)
			b = s.Substring(fifty,five)
			b = s.Substring(s.Length - one, one)
			b = s.Substring(zero,one)
			b = s.Substring(two,s.Length - two)
			b = s.Substring(eleven,s.Length - eleven - eleven)
			
			b = s.Substring(fifty,s.Length - fifty)
			b = s.Substring(zero,twentyfive)
			b = s.Substring(fifty,five)
			b = s.Substring(s.Length - one, one)
			b = s.Substring(zero,one)
			b = s.Substring(two,s.Length - two)
			b = s.Substring(eleven,s.Length - eleven - eleven)
			
			b = s.Substring(fifty,s.Length - fifty)
			b = s.Substring(zero,twentyfive)
			b = s.Substring(fifty,five)
			b = s.Substring(s.Length - one, one)
			b = s.Substring(zero,one)
			b = s.Substring(two,s.Length - two)
			b = s.Substring(eleven,s.Length - eleven - eleven)
			
			b = s.Substring(fifty,s.Length - fifty)
			b = s.Substring(zero,twentyfive)
			b = s.Substring(fifty,five)
			b = s.Substring(s.Length - one, one)
			b = s.Substring(zero,one)
			b = s.Substring(two,s.Length - two)
			b = s.Substring(eleven,s.Length - eleven - eleven)
			
			b = s.Substring(fifty,s.Length - fifty)
			b = s.Substring(zero,twentyfive)
			b = s.Substring(fifty,five)
			b = s.Substring(s.Length - one, one)
			b = s.Substring(zero,one)
			b = s.Substring(two,s.Length - two)
			b = s.Substring(eleven,s.Length - eleven - eleven)	
		
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()