import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()	
		test = PointsBech()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return null	

class Test:
	pass

class Node:
	public data as duck
	public next as duck
	
	public def constructor(data as duck, next as duck):
		self.data = data
		self.next = next
		
class Point3D:
	public x as duck
	public y as duck
	public z as duck
	public dimensions as duck
	public def constructor(x as duck,y as duck,z as duck,dimensions as duck):
		self.x = x
		self.y = y
		self.z = z	
		self.dimensions = dimensions
		
class Point2D:
	public x as duck
	public y as duck
	public dimensions as duck
	public def constructor(x as duck,y as duck,dimensions as duck):
		self.x = x
		self.y = y		
		self.dimensions = dimensions

class PointsBech(Test):
	def createPoint(dimensions as duck, x as duck, y as duck, z as duck) as duck:
		point as duck
		if (dimensions == 2):
			point = Point2D(x,y,dimensions)
		else:
			point = Point3D(x,y,z,3)
		return point

	def createPoints(number as duck) as duck:
		i as duck
		list as duck
		point as duck
		i = 1
		point = createPoint(3,0,0,0)
		list = Node(point, 0)
		while(i < number): 		
			point = createPoint(i % 2 + 2, number/2 - i, i, i)
			list = Node(point, list)
			i = i + 1
		return list

	def positiveX(list as duck, n as duck) as duck:
		i as duck
		l as duck 
		result as duck
		result = 0
		i = 0
		l = list
		while(i < n):			
			if(l.data.x >= 0):
				result = Node(l.data,result)
			l = l.next
			i = i + 1			
		return result
	
	def distance3D(point as duck) as duck:
		value as duck
		value = 2147483647
		if (point.dimensions == 3):
			value = point.x*point.x + point.y*point.y + point.z*point.z
		return value
		
	def closestToOrigin3D(list as duck, n as duck) as duck:		
		i as duck
		minDistance as duck
		l as duck
		point3D as duck
		
		point3D = createPoint(3,0,0,0)
		minDistance = 2147483647
		l = list
		i = 0
		while(i < n):
			if(distance3D(l.data)<minDistance):				
				minDistance = distance3D(l.data)
				point3D = l.data				
			l = l.next
			i = i + 1			
		return point3D
		
		
	def test():
		numberOfPoints as duck
		list as duck
		positive as duck
		point as duck					
		numberOfPoints = 10000
		list = createPoints(numberOfPoints)			
		positive = positiveX(list, numberOfPoints)  
		point = closestToOrigin3D(list, numberOfPoints)
				
args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()