import System

class Chronometer:
	private ticks1 as DateTime
	private ticks2 as DateTime
	
	private stopped as bool

	public def start():
		self.ticks1 = DateTime.Now
		self.stopped = false

	public def stop():
		self.ticks2 = DateTime.Now
		self.stopped = true

	private def ticksToMicroSeconds(t1 as DateTime, t2 as DateTime) as int:
		difference as TimeSpan
		difference = t2.Subtract(t1)
		return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000) * 1000

	public def getMicroSeconds() as int:
		if self.stopped:
			return self.ticksToMicroSeconds(ticks1, ticks2)
		return self.ticksToMicroSeconds(ticks1, DateTime.Now)
		
class BenchMark:
	protected iterations as int
	protected microSeconds as int
	
	public def run() as int:
		for i in range(iterations):
			self.runOneIteration()
		return self.microSeconds
		
	public virtual def runOneIteration() as object:
		return null

class ArithmethicBenchmark(BenchMark):
	public def constructor(iterations as int):
		self.iterations = iterations
		
	public def runOneIteration() as object:		
		chronometer as Chronometer
		chronometer = Chronometer()
		value as Object
		value = null
		pystone as Pystone
		pystone = Pystone()
		
		chronometer.start()
		value = pystone.pystones(5000)
		chronometer.stop()
		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return value	
		
class Idents:
	public static Ident1 as duck = 1
	public static Ident2 as duck = 2
	public static Ident3 as duck = 3
	public static Ident4 as duck = 4
	public static Ident5 as duck = 5	

class Record:
	public PtrComp as duck
	public Discr as duck
	public EnumComp as duck
	public IntComp as duck
	public StringComp as duck

	public def constructor(Discr as duck, EnumComp as duck, IntComp as duck, StringComp as duck):	
		self.Discr = Discr  
		self.EnumComp = EnumComp
		self.IntComp = IntComp
		self.StringComp = StringComp
		
	public def copy():		
		record = Record(self.Discr, self.EnumComp, self.IntComp, self.StringComp)
		record.PtrComp = self.PtrComp
		return record		

class Pystone:	
	public static IntGlob as duck
	public static BoolGlob as duck
	public static Char1Glob as duck
	public static Char2Glob as duck
	public static Array1Glob as (int,1)
	public static Array2Glob as (int,2)
	public static PtrGlb as duck
	public static PtrGlbNext as duck
	
	public def constructor():	
		Pystone.IntGlob = 0
		Pystone.BoolGlob = false
		Pystone.Char1Glob = char('\0')
		Pystone.Char2Glob = char('\0')
		Pystone.Array1Glob = array(int,51)
		Pystone.Array2Glob = matrix(int,51,51)
		for i in range(51):
			for j in range(51):
				Pystone.Array2Glob[i,j] = 0
		
	
	public static def pystones(loops as duck) as duck:
		return Pystone.Proc0(loops)

	private static def Proc0(loops as duck) as duck:
		chronometer as Chronometer
		chronometer = Chronometer()
		chronometer.start()
		for i in range(loops):
			pass
		chronometer.stop()
		nulltime = chronometer.getMicroSeconds()
		
		Pystone.PtrGlbNext = Record(0, Idents.Ident1, 0, "")
		Pystone.PtrGlb = Record(0, Idents.Ident1, 0, "")
		Pystone.PtrGlb.PtrComp = PtrGlbNext
		Pystone.PtrGlb.Discr = Idents.Ident1
		Pystone.PtrGlb.EnumComp = Idents.Ident3
		Pystone.PtrGlb.IntComp = 40
		Pystone.PtrGlb.StringComp = "DHRYSTONE PROGRAM, SOME STRING"
		String1Loc as duck = "DHRYSTONE PROGRAM, 1'ST STRING"
		Pystone.Array2Glob[8,7] = 10
		
		chronometer.start()			
		for i in range(loops):			
			Pystone.DoWork()			
		chronometer.stop()
		benchtime = chronometer.getMicroSeconds()
		
		if benchtime == 0.0:
			loopsPerBenchtime = 0.0
		else:
			loopsPerBenchtime = (loops / benchtime)
		return benchtime, loopsPerBenchtime		
		
	public static def DoWork():	
		self.Proc5()
		self.Proc4()
		IntLoc1 as duck = 2		
		IntLoc2 as duck = 3		
		IntLoc3 as duck
		String2Loc as duck 
		String2Loc = "DHRYSTONE PROGRAM, 2'ND STRING"
		String1Loc as duck
		String1Loc = "DHRYSTONE PROGRAM, 1'ST STRING"
		EnumLoc as duck 
		EnumLoc = Idents.Ident2
		Pystone.BoolGlob = not self.Func2(String1Loc, String2Loc)		
		while IntLoc1 < IntLoc2:
			IntLoc3 = 5 * IntLoc1 - IntLoc2
			IntLoc3 = self.Proc7(IntLoc1, IntLoc2)
			IntLoc1 = IntLoc1 + 1
		self.Proc8(Pystone.Array1Glob, Pystone.Array2Glob, IntLoc1, IntLoc3)
		Pystone.PtrGlb = self.Proc1(Pystone.PtrGlb)
		CharIndex as duck
		CharIndex = char('A')
		while CharIndex.CompareTo(Pystone.Char2Glob) <= 0:
			if EnumLoc == self.Func1(CharIndex, char('B')):
				EnumLoc = self.Proc6(Idents.Ident1)			
			CharIndex = (CharIndex cast int + 1) cast char
		IntLoc3 = IntLoc2 * IntLoc1
		IntLoc2 = IntLoc3 / IntLoc1
		IntLoc2 = 7 * (IntLoc3 - IntLoc2) - IntLoc1
		IntLoc1 = self.Proc2(IntLoc1)
		
	public static def Proc1(PtrParIn as duck) as duck:
		NextRecord as duck
		PtrParIn.PtrComp = NextRecord = Pystone.PtrGlb.copy()
		PtrParIn.IntComp = 5
		NextRecord.IntComp = PtrParIn.IntComp
		NextRecord.PtrComp = PtrParIn.PtrComp
		NextRecord.PtrComp = self.Proc3(NextRecord.PtrComp)
		if NextRecord.Discr == Idents.Ident1:
			NextRecord.IntComp = 6
			NextRecord.EnumComp = self.Proc6(PtrParIn.EnumComp)
			NextRecord.PtrComp = self.PtrGlb.PtrComp
			NextRecord.IntComp = self.Proc7(NextRecord.IntComp, 10)
		else:
			PtrParIn = NextRecord.copy()
		NextRecord.PtrComp = null
		return PtrParIn
		
		
	public static def Proc2(IntParIO as duck) as duck:
		EnumLoc as duck 
		IntLoc as duck
		IntLoc = IntParIO + 10
		while 1:
			if Pystone.Char1Glob == char('A'):
				IntLoc = IntLoc - 1
				IntParIO = IntLoc - Pystone.IntGlob
				EnumLoc = Idents.Ident1
			if EnumLoc == Idents.Ident1:
				break
		return IntParIO
		
	public static def Proc3(PtrParOut as duck) as duck:
		if Pystone.PtrGlb is not null:
			PtrParOut = Pystone.PtrGlb.PtrComp
		else:
			Pystone.IntGlob = 100
		Pystone.PtrGlb.IntComp = self.Proc7(10, Pystone.IntGlob)
		return PtrParOut
		
	public static def Proc4():
		BoolLoc as duck
		BoolLoc = Pystone.Char1Glob == char('A')
		BoolLoc = BoolLoc or Pystone.BoolGlob
		Pystone.Char2Glob = char('B')

	public static def Proc5():
		Pystone.Char1Glob = char('A')
		Pystone.BoolGlob = false		
		
	public static def Proc6(EnumParIn as duck) as duck:
		EnumParOut as duck
		EnumParOut = EnumParIn
		if not self.Func3(EnumParIn):
			EnumParOut = Idents.Ident4
		if EnumParIn == Idents.Ident1:
			EnumParOut = Idents.Ident1
		elif EnumParIn == Idents.Ident2:
			if Pystone.IntGlob > 100:
				EnumParOut = Idents.Ident1
			else:
				EnumParOut = Idents.Ident4
		elif EnumParIn == Idents.Ident3:
			EnumParOut = Idents.Ident2
		elif EnumParIn == Idents.Ident4:
			pass
		elif EnumParIn == Idents.Ident5:
			EnumParOut = Idents.Ident3
		return EnumParOut
		
	public static def Proc7(IntParI1 as duck , IntParI2 as duck) as duck:
		IntLoc as duck
		IntParOut as duck
		IntLoc = IntParI1 + 2
		IntParOut = IntParI2 + IntLoc
		return IntParOut		
		
	public static def Proc8(Array1Par as duck, Array2Par as (duck,2), IntParI1 as duck, IntParI2 as duck):
		IntLoc as duck
		IntLoc = IntParI1 + 5		
		Array1Par[IntLoc] = IntParI2
		Array1Par[IntLoc+1] = Array1Par[IntLoc]
		Array1Par[IntLoc+30] = IntLoc
		for IntIndex in range(IntLoc, IntLoc+2):						
			Array2Par[IntLoc,IntIndex] = IntLoc
		Array2Par[IntLoc,IntLoc-1] = Array2Par[IntLoc,IntLoc-1] + 1
		Array2Par[IntLoc+20,IntLoc] = Array1Par[IntLoc]
		Pystone.IntGlob = 5
		
	public static def Func1(CharPar1 as duck, CharPar2 as duck) as duck:
		CharLoc1 as duck
		CharLoc2 as duck
		CharLoc1 = CharPar1
		CharLoc2 = CharLoc1
		if CharLoc2 != CharPar2:
			return Idents.Ident1
		else:
			return Idents.Ident2

	public static def Func2(StrParI1 as duck, StrParI2 as duck) as duck:
		IntLoc as duck
		CharLoc as duck
		IntLoc = 1
		while IntLoc <= 1:
			if self.Func1(StrParI1[IntLoc], StrParI2[IntLoc+1]) == Idents.Ident1:
				CharLoc = char('A')
				IntLoc = IntLoc + 1
		if CharLoc.CompareTo(char('W')) >= 0 and CharLoc.CompareTo(char('Z')) <= 0:
			IntLoc = 7
		if CharLoc.Equals(char('X')):
			return true
		else:
			if StrParI1.CompareTo(StrParI2) > 0:
				IntLoc = IntLoc + 7
				return true
			else:
				return false
			
	public static def Func3(EnumParIn as duck) as duck:
		EnumLoc as duck
		EnumLoc = EnumParIn
		if EnumLoc == Idents.Ident3: return true
		return false

args = argv
def main():
	if args.Length < 1: 
		print ("You must pass the number of thousands iterations.")
		System.Environment.Exit(-1)
	
	iterations as int
	iterations = Convert.ToInt32(args[0])
	arith as ArithmethicBenchmark
	arith = ArithmethicBenchmark(iterations)
	Console.WriteLine(arith.run())	

main()