using System;

namespace Pybench.Aritmethic
{
	public class Chronometer
	{
		private DateTime ticks1, ticks2;
		private bool stopped;

		public void Start()
		{
			ticks1 = DateTime.Now;
			stopped = false;
		}
		public void Stop()
		{
			ticks2 = DateTime.Now;
			stopped = true;
		}

		private static int TicksToMicroSeconds(DateTime t1, DateTime t2)
		{
			return TicksToMiliSeconds(t1, t2) * 1000;
		}

		private static int TicksToMiliSeconds(DateTime t1, DateTime t2)
		{
			TimeSpan difference = t2.Subtract(t1);
			return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000);
		}

		private static int TicksToSeconds(DateTime t1, DateTime t2)
		{
			TimeSpan difference = t2.Subtract(t1);
			return (difference.Seconds + difference.Minutes * 60);
		}

		public int GetMicroSeconds()
		{
			if (stopped)
				return TicksToMicroSeconds(ticks1, ticks2);
			return TicksToMicroSeconds(ticks1, DateTime.Now);
		}

		public int GetMiliSeconds()
		{
			if (stopped)
				return TicksToMiliSeconds(ticks1, ticks2);
			return TicksToMiliSeconds(ticks1, DateTime.Now);
		}

		public int GetSeconds()
		{
			if (stopped)
				return TicksToSeconds(ticks1, ticks2);
			return TicksToSeconds(ticks1, DateTime.Now);
		}
	}
	
	public class BenchMark 
	{
		private int iterations;
		protected int microSeconds;

		public BenchMark(int iterations) 
		{
			this.iterations = iterations;
		}

		public int run() 
		{
			BenchMark self = this;			
			for (int i = 0; i < iterations; i++)
				self.runOneIteration();
			return this.microSeconds;
		}

		virtual public object runOneIteration() { return null; }
	}
	
	public class ArithmethicBenchmark : BenchMark 
	{
		public ArithmethicBenchmark(int iterations) : base(iterations) { }	
		public override object runOneIteration() 
		{				
			Chronometer chronometer = new Chronometer();
			Test test = new TryExcept();						
			chronometer.Start();				
			test.test();
			chronometer.Stop();			
			this.microSeconds = this.microSeconds + chronometer.GetMicroSeconds();
			return null;
		}
	}
	
	public abstract class Test {
		public abstract void test();
	}

	public class TryExcept : Test 
	{		
		public override void test() 
		{
			dynamic i = 0;
			dynamic temp;
			while(i < 150000)
			{
				try { temp = i;}
				catch (Exception ex0) { }
				try { temp = i;}
				catch (Exception ex1) { }
				try { temp = i;}
				catch (Exception ex2) { }
				try { temp = i;}
				catch (Exception ex3) { }
				try { temp = i;}
				catch (Exception ex4) { }
				try { temp = i;}
				catch (Exception ex5) { }
				try { temp = i;}
				catch (Exception ex6) { }
				try { temp = i;}
				catch (Exception ex7) { }
				try { temp = i;}
				catch (Exception ex8) { }
				try { temp = i;}
				catch (Exception ex9) { }
				
				try { temp = i;}
				catch (Exception ex10) { }
				try { temp = i;}
				catch (Exception ex11) { }
				try { temp = i;}
				catch (Exception ex12) { }
				try { temp = i;}
				catch (Exception ex13) { }
				try { temp = i;}
				catch (Exception ex14) { }
				try { temp = i;}
				catch (Exception ex15) { }
				try { temp = i;}
				catch (Exception ex16) { }
				try { temp = i;}
				catch (Exception ex17) { }
				try { temp = i;}
				catch (Exception ex18) { }
				try { temp = i;}
				catch (Exception ex19) { }
				
				try { temp = i;}
				catch (Exception ex20) { }
				try { temp = i;}
				catch (Exception ex21) { }
				try { temp = i;}
				catch (Exception ex22) { }
				try { temp = i;}
				catch (Exception ex23) { }
				try { temp = i;}
				catch (Exception ex24) { }
				try { temp = i;}
				catch (Exception ex25) { }
				try { temp = i;}
				catch (Exception ex26) { }
				try { temp = i;}
				catch (Exception ex27) { }
				try { temp = i;}
				catch (Exception ex28) { }
				try { temp = i;}
				catch (Exception ex29) { }
				
				try { temp = i;}
				catch (Exception ex30) { }
				try { temp = i;}
				catch (Exception ex31) { }
				try { temp = i;}
				catch (Exception ex32) { }
				try { temp = i;}
				catch (Exception ex33) { }
				try { temp = i;}
				catch (Exception ex34) { }
				try { temp = i;}
				catch (Exception ex35) { }
				try { temp = i;}
				catch (Exception ex36) { }
				try { temp = i;}
				catch (Exception ex37) { }
				try { temp = i;}
				catch (Exception ex38) { }
				try { temp = i;}
				catch (Exception ex39) { }
				
				try { temp = i;}
				catch (Exception ex40) { }
				try { temp = i;}
				catch (Exception ex41) { }
				try { temp = i;}
				catch (Exception ex42) { }
				try { temp = i;}
				catch (Exception ex43) { }
				try { temp = i;}
				catch (Exception ex44) { }
				try { temp = i;}
				catch (Exception ex45) { }
				try { temp = i;}
				catch (Exception ex46) { }
				try { temp = i;}
				catch (Exception ex47) { }
				try { temp = i;}
				catch (Exception ex48) { }
				try { temp = i;}
				catch (Exception ex49) { }
				
				try { temp = i;}				
				catch (Exception ex50) { }
				try { temp = i;}
				catch (Exception ex51) { }
				try { temp = i;}
				catch (Exception ex52) { }
				try { temp = i;}
				catch (Exception ex53) { }
				try { temp = i;}
				catch (Exception ex54) { }
				try { temp = i;}
				catch (Exception ex55) { }
				try { temp = i;}
				catch (Exception ex56) { }
				try { temp = i;}
				catch (Exception ex57) { }
				try { temp = i;}
				catch (Exception ex58) { }
				try { temp = i;}
				catch (Exception ex59) { }
				
				try { temp = i;}
				catch (Exception ex60) { }
				try { temp = i;}
				catch (Exception ex61) { }
				try { temp = i;}
				catch (Exception ex62) { }
				try { temp = i;}
				catch (Exception ex63) { }
				try { temp = i;}
				catch (Exception ex64) { }
				try { temp = i;}
				catch (Exception ex65) { }
				try { temp = i;}
				catch (Exception ex66) { }
				try { temp = i;}
				catch (Exception ex67) { }
				try { temp = i;}
				catch (Exception ex68) { }
				try { temp = i;}
				catch (Exception ex69) { }
								
				try { temp = i;}				
				catch (Exception ex70) { }
				try { temp = i;}
				catch (Exception ex71) { }
				try { temp = i;}
				catch (Exception ex72) { }
				try { temp = i;}
				catch (Exception ex73) { }
				try { temp = i;}
				catch (Exception ex74) { }
				try { temp = i;}
				catch (Exception ex75) { }
				try { temp = i;}
				catch (Exception ex76) { }
				try { temp = i;}
				catch (Exception ex77) { }
				try { temp = i;}
				catch (Exception ex78) { }
				try { temp = i;}
				catch (Exception ex79) { }
				
				try { temp = i;}				
				catch (Exception ex80) { }
				try { temp = i;}
				catch (Exception ex81) { }
				try { temp = i;}
				catch (Exception ex82) { }
				try { temp = i;}
				catch (Exception ex83) { }
				try { temp = i;}
				catch (Exception ex84) { }
				try { temp = i;}
				catch (Exception ex85) { }
				try { temp = i;}
				catch (Exception ex86) { }
				try { temp = i;}
				catch (Exception ex87) { }
				try { temp = i;}
				catch (Exception ex88) { }
				try { temp = i;}
				catch (Exception ex89) { }
				
				try { temp = i;}				
				catch (Exception ex90) { }
				try { temp = i;}
				catch (Exception ex91) { }
				try { temp = i;}
				catch (Exception ex92) { }
				try { temp = i;}
				catch (Exception ex93) { }
				try { temp = i;}
				catch (Exception ex94) { }
				try { temp = i;}
				catch (Exception ex95) { }
				try { temp = i;}
				catch (Exception ex96) { }
				try { temp = i;}
				catch (Exception ex97) { }
				try { temp = i;}
				catch (Exception ex98) { }
				try { temp = i;}
				catch (Exception ex99) { }
				
				try { temp = i;}
				catch (Exception ex100) { }
				try { temp = i;}
				catch (Exception ex101) { }
				try { temp = i;}
				catch (Exception ex102) { }
				try { temp = i;}
				catch (Exception ex103) { }
				try { temp = i;}
				catch (Exception ex104) { }
				try { temp = i;}
				catch (Exception ex105) { }
				try { temp = i;}
				catch (Exception ex106) { }
				try { temp = i;}
				catch (Exception ex107) { }
				try { temp = i;}
				catch (Exception ex108) { }
				try { temp = i;}
				catch (Exception ex109) { }
								
				try { temp = i;}
				catch (Exception ex110) { }
				try { temp = i;}
				catch (Exception ex111) { }
				try { temp = i;}
				catch (Exception ex112) { }
				try { temp = i;}
				catch (Exception ex113) { }
				try { temp = i;}
				catch (Exception ex114) { }
				try { temp = i;}
				catch (Exception ex115) { }
				try { temp = i;}
				catch (Exception ex116) { }
				try { temp = i;}
				catch (Exception ex117) { }
				try { temp = i;}
				catch (Exception ex118) { }
				try { temp = i;}
				catch (Exception ex119) { }
				  
				try { temp = i;}				  
				catch (Exception ex120) { }
				try { temp = i;}
				catch (Exception ex121) { }
				try { temp = i;}
				catch (Exception ex122) { }
				try { temp = i;}
				catch (Exception ex123) { }
				try { temp = i;}
				catch (Exception ex124) { }
				try { temp = i;}
				catch (Exception ex125) { }
				try { temp = i;}
				catch (Exception ex126) { }
				try { temp = i;}
				catch (Exception ex127) { }
				try { temp = i;}
				catch (Exception ex128) { }
				try { temp = i;}
				catch (Exception ex129) { }
				
				try { temp = i;}
				catch (Exception ex130) { }
				try { temp = i;}
				catch (Exception ex131) { }
				try { temp = i;}
				catch (Exception ex132) { }
				try { temp = i;}
				catch (Exception ex133) { }
				try { temp = i;}
				catch (Exception ex134) { }
				try { temp = i;}
				catch (Exception ex135) { }
				try { temp = i;}
				catch (Exception ex136) { }
				try { temp = i;}
				catch (Exception ex137) { }
				try { temp = i;}
				catch (Exception ex138) { }
				try { temp = i;}
				catch (Exception ex139) { }
				
				try { temp = i;}				
				catch (Exception ex140) { }
				try { temp = i;}
				catch (Exception ex141) { }
				try { temp = i;}
				catch (Exception ex142) { }
				try { temp = i;}
				catch (Exception ex143) { }
				try { temp = i;}
				catch (Exception ex144) { }
				try { temp = i;}
				catch (Exception ex145) { }
				try { temp = i;}
				catch (Exception ex146) { }
				try { temp = i;}
				catch (Exception ex147) { }
				try { temp = i;}
				catch (Exception ex148) { }
				try { temp = i;}
				catch (Exception ex149) { }
								
				i=i+1;
			}
		}
	}
	
	public class Program 
	{
		public static void Main(string[] args) 
		{
			if (args.Length<1) {
				Console.Error.WriteLine("You must pass the number of thousands iterations.");
					System.Environment.Exit(-1);
			}
			int iterations = Convert.ToInt32(args[0]);
			ArithmethicBenchmark arith = new ArithmethicBenchmark(iterations);
			Console.WriteLine(arith.run());
		}
	}
}