public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := PythonMethodCalls();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }


public class C 
  {
        Obj? x;
        Obj? y;
        Obj? t;
        Obj? s;
		
		new make()
		{
			this.x = 2;
			this.s = "string"
		}

        public Obj? f()
        {
            return this.x;
        }

        public Obj? j(Obj? a, Obj? b)
        {
            this.y = a;
            this.t = b;
            return this.y;
        }

        public Void k(Obj? a, Obj? b, Obj? c)
        {
            this.y = a;
            this.s = b.toStr();
            this.t = c;
        }
    }


 public class PythonMethodCalls : TestPyBench 
  {   
        public override Void test() 
    {
            Obj? o := C();
            Obj? two := 2;
            Obj? three := 3;
            Obj? four := 4;
            for ( i := 0; i < 30000; i++)
            {
                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->j(i, i);
                o->j(i, i);
                o->j(i, two);
                o->j(i, two);
                o->j(two, two);
                o->k(i, i, three);
                o->k(i, two, three);
                o->k(i, two, three);
                o->k(i, i, four);

                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->j(i, i);
                o->j(i, i);
                o->j(i, two);
                o->j(i, two);
                o->j(two, two);
                o->k(i, i, three);
                o->k(i, two, three);
                o->k(i, two, three);
                o->k(i, i, four);

                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->j(i, i);
                o->j(i, i);
                o->j(i, two);
                o->j(i, two);
                o->j(two, two);
                o->k(i, i, three);
                o->k(i, two, three);
                o->k(i, two, three);
                o->k(i, i, four);

                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->j(i, i);
                o->j(i, i);
                o->j(i, two);
                o->j(i, two);
                o->j(two, two);
                o->k(i, i, three);
                o->k(i, two, three);
                o->k(i, two, three);
                o->k(i, i, four);

                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->f();
                o->j(i, i);
                o->j(i, i);
                o->j(i, two);
                o->j(i, two);
                o->j(two, two);
                o->k(i, i, three);
                o->k(i, two, three);
                o->k(i, two, three);
                o->k(i, i, four);
            }
        }
    }


public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}