public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := ForLoops();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }


public class ForLoops : TestPyBench 
{   
  public override Void test() 
    {
    Obj? l1 := Obj?[100];      
    for ( i := 0; i < 100; i=i+1) l1->add(i);
      
    Obj? temp := 0;
    for ( x := 0; x < 10000; x = x + 1)
    {
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
      temp = 0; for ( i := 0; i < l1->size; i=i+1) temp = temp->plus(1);
    }
  }
}     

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}