public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := NestedForLoops();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }


 public class NestedForLoops : TestPyBench
  {   
        public override Void test() 
    {               
            Obj? l1 := Obj?[1000];
            Obj? l2 := Obj?[10];
            Obj? l3 := Obj?[5];

            for (Obj? i := 0; i < 1000; i=i->plus(1)) l1->add(i);
            for (Obj? i := 0; i < 10; i=i->plus(1)) l2->add(i);
            for (Obj? i := 0; i < 5; i=i->plus(1)) l3->add(i);

            Obj? count := 0;
			Obj? x := 0;
            while(count < 300)
            {
                for ( j := 0 ; j < l1->size; j=j->plus(1))
                {
                  for ( k := 0 ; k < l2->size; k=k->plus(1)) 
                  {
                    for ( l := 0 ; l < l3->size; l=l->plus(1))
					{
						x=x->plus(1);
					} 
                  }
                }
                count=count->plus(1)
            }
        }
    }

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}