public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := DictCreation();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }
    
    public class DictCreation : TestPyBench
    {   
      public override Void test() 
      { 
            Obj? i;
            Obj? two;
            Obj? three;
            Obj? four;
            Obj? five;
            Obj? six;
            Obj? seven;
            Obj? eight;
            Obj? nine;
            Obj? ten;
            Obj? eleven;
        
            i = 0;
            two = 2;
            three = 3;
            four = 4;
            five = 5;
            six = 6;
            seven = 7;
            eight = 8;
            nine = 9;
            ten = 10;
            eleven = 11;

            while (i < 80000)
            {
                Obj? d1;
                Obj? d2;
                Obj? d3;
                Obj? d4;
                Obj? d5;
              
                d1 = [,];
                d2 = [,];
                d3 = [,];
                d4 = [,];
                d5 = [,];
              
                d1 = [1:two,3:four,5:six]
                d2 = [2:three,4:five,6:seven]
                d3 = [3:four,5:six,7:eight]
                d4 = [4:five,6:seven,8:nine]
                d5 = [6:seven,8:nine,10:eleven]

                d1 = [,];
                d2 = [,];
                d3 = [,];
                d4 = [,];
                d5 = [,];
              
                d1 = [1:two,3:four,5:six]
                d2 = [2:three,4:five,6:seven]
                d3 = [3:four,5:six,7:eight]
                d4 = [4:five,6:seven,8:nine]
                d5 = [6:seven,8:nine,10:eleven]

                d1 = [,];
                d2 = [,];
                d3 = [,];
                d4 = [,];
                d5 = [,];
              
                d1 = [1:two,3:four,5:six]
                d2 = [2:three,4:five,6:seven]
                d3 = [3:four,5:six,7:eight]
                d4 = [4:five,6:seven,8:nine]
                d5 = [6:seven,8:nine,10:eleven]

                d1 = [,];
                d2 = [,];
                d3 = [,];
                d4 = [,];
                d5 = [,];
              
                d1 = [1:two,3:four,5:six]
                d2 = [2:three,4:five,6:seven]
                d3 = [3:four,5:six,7:eight]
                d4 = [4:five,6:seven,8:nine]
                d5 = [6:seven,8:nine,10:eleven]

                d1 = [,];
                d2 = [,];
                d3 = [,];
                d4 = [,];
                d5 = [,];
              
                d1 = [1:two,3:four,5:six]
                d2 = [2:three,4:five,6:seven]
                d3 = [3:four,5:six,7:eight]
                d4 = [4:five,6:seven,8:nine]
                d5 = [6:seven,8:nine,10:eleven]

                i = i->plus(1);
            }
        }
    }

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}