public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := DictWithFloatKeys();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }
    
    public class DictWithFloatKeys : TestPyBench
    {   
      public override Void test() 
      { 
            Obj? temp;
            Obj? one;
            Obj? two;
            Obj? three;
            Obj? four;
            Obj? five;
            Obj? six;
        
            one = 1;
            two = 2;
            three = 3;
            four = 4;
            five = 5;
            six = 6;
            
            Obj? d;            
            d = [:];

            for ( i := 0; i < 150000; i = i->plus(1))
            {       
              d = [1.234f:one,2.345f:two,3.456f:three,4.567f:four,5.678f:five,6.789f:six];
              temp = d->get(1.234f);
              temp = d->get(2.345f);
              temp = d->get(3.456f);
              temp = d->get(4.567f);
              temp = d->get(5.678f);
              temp = d->get(6.789f);
              
              d = [1.234f:one,2.345f:two,3.456f:three,4.567f:four,5.678f:five,6.789f:six];
              temp = d->get(1.234f);
              temp = d->get(2.345f);
              temp = d->get(3.456f);
              temp = d->get(4.567f);
              temp = d->get(5.678f);
              temp = d->get(6.789f);
              
              d = [1.234f:one,2.345f:two,3.456f:three,4.567f:four,5.678f:five,6.789f:six];
              temp = d->get(1.234f);
              temp = d->get(2.345f);
              temp = d->get(3.456f);
              temp = d->get(4.567f);
              temp = d->get(5.678f);
              temp = d->get(6.789f);
              
              d = [1.234f:one,2.345f:two,3.456f:three,4.567f:four,5.678f:five,6.789f:six];
              temp = d->get(1.234f);
              temp = d->get(2.345f);
              temp = d->get(3.456f);
              temp = d->get(4.567f);
              temp = d->get(5.678f);
              temp = d->get(6.789f);
              
              d = [1.234f:one,2.345f:two,3.456f:three,4.567f:four,5.678f:five,6.789f:six];
              temp = d->get(1.234f);
              temp = d->get(2.345f);
              temp = d->get(3.456f);
              temp = d->get(4.567f);
              temp = d->get(5.678f);
              temp = d->get(6.789f);
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}