public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := DictWithIntegerKeys();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }
    
    public class DictWithIntegerKeys : TestPyBench
    {   
      public override Void test() 
      { 
            Obj? temp;
            Obj? one;
            Obj? two;
            Obj? three;
            Obj? four;
            Obj? five;
            Obj? six;
        
            one = 1;
            two = 2;
            three = 3;
            four = 4;
            five = 5;
            six = 6;
            
            Obj? d;            
            d = [,];
            d->size(7);

            for ( i := 0; i < 200000; i = i->plus(1))
            {       
                d->set(1, one);
                d->set(2, two);
                d->set(3, three);
                d->set(4, four);
                d->set(5, five);
                d->set(6, six);
              
                temp = d->get(1);
                temp = d->get(2);
                temp = d->get(3);
                temp = d->get(4);
                temp = d->get(5);
                temp = d->get(6);

                d->set(1, one);
                d->set(2, two);
                d->set(3, three);
                d->set(4, four);
                d->set(5, five);
                d->set(6, six);
              
                temp = d->get(1);
                temp = d->get(2);
                temp = d->get(3);
                temp = d->get(4);
                temp = d->get(5);
                temp = d->get(6);

                d->set(1, one);
                d->set(2, two);
                d->set(3, three);
                d->set(4, four);
                d->set(5, five);
                d->set(6, six);
              
                temp = d->get(1);
                temp = d->get(2);
                temp = d->get(3);
                temp = d->get(4);
                temp = d->get(5);
                temp = d->get(6);

                d->set(1, one);
                d->set(2, two);
                d->set(3, three);
                d->set(4, four);
                d->set(5, five);
                d->set(6, six);
              
                temp = d->get(1);
                temp = d->get(2);
                temp = d->get(3);
                temp = d->get(4);
                temp = d->get(5);
                temp = d->get(6);

                d->set(1, one);
                d->set(2, two);
                d->set(3, three);
                d->set(4, four);
                d->set(5, five);
                d->set(6, six);
              
                temp = d->get(1);
                temp = d->get(2);
                temp = d->get(3);
                temp = d->get(4);
                temp = d->get(5);
                temp = d->get(6);              
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}