public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := TryRaiseExcept();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }
    
    public class TryRaiseExcept : TestPyBench
    {   
      
    public static Void ThrowException(Obj? message)
    {
      throw Err(message);
    }
            
      public override Void test() 
      { 
            Obj? i;
            i = 0;
            while(i < 8000)
            {
                try {
                    throw Err("hi");
                }
                catch (Err exp) { }
                finally {
                    try {
                        ThrowException("hi");
                    }
                    catch (Err exp) { }
                    try {
                        ThrowException("something");
                    }
                    catch (Err exp) { }
                    try {
                        ThrowException("something");
                    }
                    catch (Err exp) { }
                    try {
                        ThrowException("something");
                    }
                    catch (Err exp) { }
                    try {
                        ThrowException("something");
                    }
                    catch (Err exp) { }
                    try {
                        ThrowException("something");
                    }
                    catch (Err exp) { }
                    try {
                        ThrowException("something");
                    }
                    catch (Err exp) { }
                }
                i=i->plus(1);
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}