public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := CreateInstances();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }

public class C 
  {
        public Obj? a;
        public Obj? b;
        public Obj? c;
    }

    public class D 
  {
        public Obj? a;
        public Obj? b;
        public Obj? c;

        new make(Obj? a, Obj? b, Obj? c)
        {
            this.a = a;
            this.b = b;
            this.c = c;
        }
    }

    public class E 
  {
        public Obj? a;
        public Obj? b;
        public Obj? c;
        public Obj? d;
        public Obj? e;
        public Obj? f;

        new make(Obj? a, Obj? b, Obj? c)
        {
            this.a = a;
            this.b = b;
            this.c = c;
            this.d = a;
            this.e = b;
            this.f = c;
        }
    }
    
    public class CreateInstances : TestPyBench
    {   
      
               
      public override Void test() 
      { 
            Obj? i;
            Obj? three;
            Obj? four;
            i = 0;        
            three = 3;
            four = 4;        
            while(i < 800000)
            {                
                Obj? o;
                o = C()
                Obj? o1;
                o1 = C()
                Obj? o2;                   
                o2 = C();
                Obj? p;
                p = D(i,i,three)
                Obj? p1;
                p1 = D(i,i,three)
                Obj? p2;
                p2 = D(i,three,three)
                Obj? p3;
                p3 = D(three,i,three)
                Obj? p4;
                p4 = D(i,i,i)
                Obj? p5;
                p5 = D(three,i,three)
                Obj? p6;
                p6 = D(i,i,i)
                Obj? q;
                q = E(i,i,three)
                Obj? q1;
                q1 = E(i,i,three)
                Obj? q2;
                q2 = E(i,i,three)
                Obj? q3;
                q3 = E(i,i,four)                      
                
                i=i->plus(1);
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}