public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := NormalInstanceAttribute();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }

public class C
{
  public static const Obj? a;
  public static const Obj? b;
  public static const Obj? c;
  
  static
  {    
    Obj? two;
    Obj? three;
    Obj? four;
    
    two = 2;
    three = 3;
    four = 1;  
    
    Int x;
    for(i := 0 ; i < 100000; i=i->plus(1))
    {
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c; 
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c; 
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c; 
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c; 
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      C.a = two;
      C.b = three;
      C.c = four;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;
      
      x = C.a;
      x = C.b;
      x = C.c;       
    }
  }
}
    
    public class NormalInstanceAttribute : TestPyBench
    {   
      public override Void test() 
      { 
        Obj? c;
        c = C();        
      }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}