public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := NormalInstanceAttribute();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }

public class D
{
  public Obj? a;
  public Obj? b;
  public Obj? c;
  
  new make(Obj? a, Obj? b, Obj? c)
  {
    this.a = a;
    this.b = b;
    this.c = c;
  }
}
    
    public class NormalInstanceAttribute : TestPyBench
    {   
      public override Void test() 
      {           
          Obj? two;
          Obj? three;
          Obj? four;
                    
          two = 2;
          three = 3;
          four = 1;
        
          Obj? o;
          o = D(0,0,0);
          Obj? x;
          for(i := 0 ; i < 100000; i=i->plus(1))
          {
              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              o->a = two;
              o->b = three;
              o->c = four;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;

              x = o->a;
              x = o->b;
              x = o->c;
          }            
      }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}