public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := CompareFloats();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }
    
    public class CompareFloats : TestPyBench
    {   
      
               
      public override Void test() 
      {             
            Obj? two;
            Obj? three; 
            two = 2.1f;
            three = 3.31f;
            Obj? b;
            
            for (Obj? i := 0; i < 80000; i=i->plus(1))
            {                
                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;

                b = two < three;
                b = two > three;
                b = two == three;
                b = two > three;
                b = two < three;
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}