public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := CompareStrings();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds + chronometer.getMicroSeconds();
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }

    
    public class CompareStrings : TestPyBench
    {           
      public override Void test() 
      {             
            Obj? s;
            Obj? t;
            Obj? b;
            s = "";
            t = "";
            for (i := 0; i < 10;  i=i+1)
                s = s->plus("" + i.toStr);
            for (i := 0; i < 10;  i=i+1)
                t = t->plus("" + i.toStr);
            t = t->plus("abc");
            
            for (Obj? i := 0; i < 200000; i=i->plus(1))
            {                
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;  
              
                b = t->compare(s) < 0;       
                b = t->compare(s) > 0;       
                b = t->equals(s);       
                b = t->compare(s) > 0;       
                b = t->compare(s) < 0;                
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}