public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := CreateStringsWithConcat();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds->plus(chronometer.getMicroSeconds());
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }

    
    public class CreateStringsWithConcat : TestPyBench
    {           
      public override Void test() 
      {             
            Obj? s;
            Obj? t;
            Obj? u;
            Obj? v;        
            s = "";
            t = "";
            u = "";
            v = "";
            for (i := 0; i < 20;  i=i+1)
                s = s->plus("" + i.toStr);
            for (i := 0; i < 50;  i=i+1)
                t = t->plus("" + i.toStr);
            for (i := 0; i < 100;  i=i+1)
                u = u->plus("" + i.toStr);
            for (i := 0; i < 256;  i=i+1)
                v = v->plus("" + i.toStr);  
        
            Obj? b;
            for (Obj? i := 0; i < 70000; i=i->plus(1))
            {                
                b = s->lower();    
                b = s->lower();    
                b = s->lower();    
                b = s->lower();    
                b = s->lower();    
                
                b = s->upper();
                b = s->upper();
                b = s->upper();
                b = s->upper();
                b = s->upper();
                
                b = t->lower();    
                b = t->lower();    
                b = t->lower();    
                b = t->lower();    
                
                b = t->upper();
                b = t->upper();
                b = t->upper();
                b = t->upper();
                
                b = u->lower();    
                b = u->lower();    
                
                b = u->upper();
                b = u->upper();
                
                b = v->lower();    
                
                b = v->upper();
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}