public class Chronometer 
{
  private Int ticks1;
  private Int ticks2;
  private Bool stopped;
  
  public Void start() 
  {
    this.ticks1 = Duration.nowTicks();
    this.stopped = false;
  }

  public Void stop() {
    this.ticks2 = Duration.nowTicks();
    this.stopped = true;
  }
  
  public Int getMicroSeconds() {
    return (this.ticks2 - this.ticks1)/1000;
  } 
}

public abstract class Benchmark 
{
  private Int iterations;
  protected Int microSeconds;
  
  new make(Int iterations) 
  {
    this.iterations = iterations;
  } 
  
  public Int run() {
    for(i := 0 ; i < this.iterations ; i++)
      this.runOneIteration();
    return this.microSeconds;
  }
  
  public virtual Obj? runOneIteration() {
    return null;
  }   
}


class ArithmethicBenchmark : Benchmark 
{
  new make(Int iterations): super(iterations) {}

  public override Obj? runOneIteration() 
  {
    chronometer := Chronometer(); 
    
    test := StringPredicates();
    
    chronometer.start();
    test.test();
    chronometer.stop();   
    this.microSeconds = this.microSeconds->plus(chronometer.getMicroSeconds());
    return null;
  }
}

public abstract class TestPyBench {
        public abstract Void test();
    }

    
    public class StringPredicates : TestPyBench
    {           
      public override Void test() 
      {             
            Obj? s;
            s = "abc123-10 ABC";
            Obj? b;
            Obj? c;         
            Obj? i;
            for (i = 0; i < 100000; i=i->plus(1))
            {                
                c = s->chars->get(i->mod(s->size()));
                
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper(); 

                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper();  
              
                b = c->isAlphaNum();
                b = c->isAlpha();
                b = c->isDigit();
                b = c->isLower();
                b = c->isSpace();
                b = c->isUpper(); 
            }
       }
    }    

public class Main
{
  public static Void main(Str[] args)
  {   
    if (args.size < 1)
    {   
      echo("You must pass the number of thousands iterations.");
    }
    else
    {   
      iterations := Int.fromStr(args[0]);   
      arith := ArithmethicBenchmark(iterations)
      echo(arith.run());
    }    
  } 
}