import sys, time, operator, os, random
from time import clock
from System import Array

TRUE = 1
FALSE = 0

class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1
		
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)

class BenchMark:
	microSeconds = 0
	def __init__(self,iterations):		
		self.iterations = iterations
	
	def run(self):		
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
	
	def runOneIteration(self):
		pass	

class ArithmethicBenchmark(BenchMark):
	def __init__(self,iterations):
		self.iterations = iterations
		
	def runOneIteration(self):				
		chronometer = Chronometer()				
		test = JGFHeapSortBench()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return None

class NumericSortTest:		
	def buildTestData(self):		
		self.TestArray = Array.CreateInstance(int,self.array_rows)
		rndnum = random.Random(1729)		
		i =	0
		while i < self.array_rows:
			self.TestArray[i] = rndnum.randint(0,int.MaxValue)
			i = i + 1
	
	def Do(self):
		self.NumHeapSort()
	
	def NumSift(self,min,max):
		while (min + min) <= max:
			inc = FALSE
			if (min + min) < max and self.TestArray[min + min] < self.TestArray[min + min + 1]:
				inc = TRUE
			k =  min + min + 1 if inc else min + min
			if self.TestArray[min] < self.TestArray[k]:
				temp = self.TestArray[k]
				self.TestArray[k] = self.TestArray[min]
				self.TestArray[min] = temp
				min = k				
			else:
				min = max + 1

	def NumHeapSort(self):	
		top = self.array_rows - 1
		i = top / 2
		while i > 0:
			self.NumSift(i, top)
			i = i - 1
		i = top
		while i > 0:
			self.NumSift(0, i)
			temp = self.TestArray[0]
			self.TestArray[0] = self.TestArray[i]
			self.TestArray[i] = temp
			i = i - 1
	
class JGFHeapSortBench(NumericSortTest):
	def __init__(self):		
		self.datasizes = Array.CreateInstance(int, 3)
		self.datasizes[0] = 1000000;
		self.datasizes[1] = 5000000;
		self.datasizes[2] = 25000000;

	def JGsetsize(self,size):
		self.size = size  

	def JGinitialise(self):
		self.array_rows = self.datasizes[self.size]
		self.buildTestData()
		
	def JGFkernel(self):
		self.Do()
	
	def JGFvalidate(self):
		error = FALSE
		i = 1
		while i < self.array_rows:
			error = self.TestArray[i] < self.TestArray[i - 1]
			if error:
				'''print "Validation failed"'''
				'''print "Item " + i + " = " + self.TestArray[i]'''
				'''print "Item " + (i - 1) + " = " + self.TestArray[i - 1]'''
			i = i + 1
	
	def test(self):
		self.JGsetsize(0)
		self.JGinitialise()
		self.JGFkernel()
		self.JGFvalidate()

if __name__ == '__main__':	
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)
	iterations = int(sys.argv[1])	
	arith = ArithmethicBenchmark(iterations)
	print (str(arith.run()))