import sys, time, operator, os
from time import clock

TRUE = 1
FALSE = 0

class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1
		
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)

class BenchMark:
	microSeconds = 0
	def __init__(self,iterations):		
		self.iterations = iterations
	
	def run(self):		
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
	
	def runOneIteration(self):
		pass	

class ArithmethicBenchmark(BenchMark):
	def __init__(self,iterations):
		self.iterations = iterations
		
	def runOneIteration(self):				
		chronometer = Chronometer()				
		test = FunctionCalls()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return None
		
class Test:
	pass

class FunctionCalls(Test):
	def test(self):
		global f,f1,g,h

		# define functions
		def f():
			pass

		def f1(x):
			pass

		def g(a,b,c):
			return a,b,c

		def h(a,b,c,d=1,e=2,f=3):
			return d,e,f

		# do calls
		two = 2
		three = 3
		for i in range(60000):
			f()
			f1(i)
			f1(i)
			f1(i)
			f1(i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			h(i,i,three,i,i)
			h(i,i,i,two,i,three)

			f()
			f1(i)
			f1(i)
			f1(i)
			f1(i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			h(i,i,three,i,i)
			h(i,i,i,two,i,three)

			f()
			f1(i)
			f1(i)
			f1(i)
			f1(i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			h(i,i,three,i,i)
			h(i,i,i,two,i,three)

			f()
			f1(i)
			f1(i)
			f1(i)
			f1(i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			h(i,i,three,i,i)
			h(i,i,i,two,i,three)

			f()
			f1(i)
			f1(i)
			f1(i)
			f1(i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			g(i,i,i)
			h(i,i,three,i,i)
			h(i,i,i,two,i,three)

if __name__ == '__main__':	
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)
	iterations = int(sys.argv[1])	
	arith = ArithmethicBenchmark(iterations)
	print (str(arith.run()))