import sys, time, operator, os
from time import clock

TRUE = 1
FALSE = 0

class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1
		
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)

class BenchMark:
	microSeconds = 0
	def __init__(self,iterations):		
		self.iterations = iterations
	
	def run(self):		
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
	
	def runOneIteration(self):
		pass	

class ArithmethicBenchmark(BenchMark):
	def __init__(self,iterations):
		self.iterations = iterations
		
	def runOneIteration(self):				
		chronometer = Chronometer()				
		test = MethodCalls()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return None
		
class Test:
	pass
	
class MethodCalls(Test):
    def test(self):
        class c:
            x = 2
            s = 'string'
            def f(self):
                return self.x

            def j(self,a,b):
                self.y = a
                self.t = b
                return self.y

            def k(self,a,b,c=3):
                self.y = a
                self.s = str(b)
                self.t = c

        o = c()
        two = 2
        three = 3
        four = 4
        for i in range(30000):
            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.j(i,i)
            o.j(i,i)
            o.j(i,two)
            o.j(i,two)
            o.j(two,two)
            o.k(i,i)
            o.k(i,two)
            o.k(i,two,three)
            o.k(i,i,c=four)

            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.j(i,i)
            o.j(i,i)
            o.j(i,two)
            o.j(i,two)
            o.j(two,two)
            o.k(i,i)
            o.k(i,two)
            o.k(i,two,three)
            o.k(i,i,c=four)

            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.j(i,i)
            o.j(i,i)
            o.j(i,two)
            o.j(i,two)
            o.j(two,two)
            o.k(i,i)
            o.k(i,two)
            o.k(i,two,three)
            o.k(i,i,c=four)

            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.j(i,i)
            o.j(i,i)
            o.j(i,two)
            o.j(i,two)
            o.j(two,two)
            o.k(i,i)
            o.k(i,two)
            o.k(i,two,three)
            o.k(i,i,c=four)

            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.f()
            o.j(i,i)
            o.j(i,i)
            o.j(i,two)
            o.j(i,two)
            o.j(two,two)
            o.k(i,i)
            o.k(i,two)
            o.k(i,two,three)
            o.k(i,i,c=four)

if __name__ == '__main__':	
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)
	iterations = int(sys.argv[1])	
	arith = ArithmethicBenchmark(iterations)
	print (str(arith.run()))