import sys, time, operator, os
from time import clock

TRUE = 1
FALSE = 0

class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1
		
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)

class BenchMark:
	microSeconds = 0
	def __init__(self,iterations):		
		self.iterations = iterations
	
	def run(self):		
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
	
	def runOneIteration(self):
		pass	

class ArithmethicBenchmark(BenchMark):
	def __init__(self,iterations):
		self.iterations = iterations
		
	def runOneIteration(self):				
		chronometer = Chronometer()				
		test = SimpleDictManipulation()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return None
		
class Test:
	pass

class SimpleDictManipulation(Test):
	def test(self):
		zero = 0
		one = 1
		two = 2
		three = 3
		four = 4
		five = 5
		six = 6
		eight = 8
		ten = 10
		d = {}
		has_key = lambda key: key in d

		for i in range(100000):
			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			has_key(zero)
			has_key(two)
			has_key(four)
			has_key(six)
			has_key(eight)
			has_key(ten)

			del d[0]
			del d[1]
			del d[2]
			del d[3]
			del d[4]
			del d[5]

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			has_key(zero)
			has_key(two)
			has_key(four)
			has_key(six)
			has_key(eight)
			has_key(ten)

			del d[0]
			del d[1]
			del d[2]
			del d[3]
			del d[4]
			del d[5]

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			has_key(zero)
			has_key(two)
			has_key(four)
			has_key(six)
			has_key(eight)
			has_key(ten)

			del d[0]
			del d[1]
			del d[2]
			del d[3]
			del d[4]
			del d[5]

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			has_key(zero)
			has_key(two)
			has_key(four)
			has_key(six)
			has_key(eight)
			has_key(ten)

			del d[0]
			del d[1]
			del d[2]
			del d[3]
			del d[4]
			del d[5]

			d[0] = three
			d[1] = four
			d[2] = five
			d[3] = three
			d[4] = four
			d[5] = five

			x = d[0]
			x = d[1]
			x = d[2]
			x = d[3]
			x = d[4]
			x = d[5]

			has_key(zero)
			has_key(two)
			has_key(four)
			has_key(six)
			has_key(eight)
			has_key(ten)

			del d[0]
			del d[1]
			del d[2]
			del d[3]
			del d[4]
			del d[5]

if __name__ == '__main__':	
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)
	iterations = int(sys.argv[1])	
	arith = ArithmethicBenchmark(iterations)
	print (str(arith.run()))