import sys, time, operator, os
from time import clock

TRUE = 1
FALSE = 0

class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1
		
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)

class BenchMark:
	microSeconds = 0
	def __init__(self,iterations):		
		self.iterations = iterations
	
	def run(self):		
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
	
	def runOneIteration(self):
		pass	

class ArithmethicBenchmark(BenchMark):
	def __init__(self,iterations):
		self.iterations = iterations
		
	def runOneIteration(self):				
		chronometer = Chronometer()				
		test = CreateInstances()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return None
		
class Test:
	pass

class CreateInstances(Test):
    def test(self):
        three = 3
        class c:
            pass

        class d:
            def __init__(self,a,b,c):
                self.a = a
                self.b = b
                self.c = c

        class e:
            def __init__(self,a,b,c=4):
                self.a = a
                self.b = b
                self.c = c
                self.d = a
                self.e = b
                self.f = c
		
        for i in range(800000):
            o = c()
            o1 = c()
            o2 = c()
            p = d(i,i,three)
            p1 = d(i,i,three)
            p2 = d(i,three,three)
            p3 = d(three,i,three)
            p4 = d(i,i,i)
            p5 = d(three,i,three)
            p6 = d(i,i,i)
            q = e(i,i,three)
            q1 = e(i,i,three)
            q2 = e(i,i,three)
            q3 = e(i,i)

if __name__ == '__main__':	
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)
	iterations = int(sys.argv[1])	
	arith = ArithmethicBenchmark(iterations)
	print (str(arith.run()))