import sys, time, operator, os
from time import clock

TRUE = 1
FALSE = 0

class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1
		
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)

class BenchMark:
	microSeconds = 0
	def __init__(self,iterations):		
		self.iterations = iterations
	
	def run(self):		
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
	
	def runOneIteration(self):
		pass	

class ArithmethicBenchmark(BenchMark):
	def __init__(self,iterations):
		self.iterations = iterations
		
	def runOneIteration(self):				
		chronometer = Chronometer()				
		test = ListSlicing()		
		chronometer.start()
		test.test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return None
		
class Test:
	pass

class ListSlicing(Test):
    def test(self):
        n = list(range(100))
        r = list(range(25))

        for i in range(800):
            l = n[:]
            for j in r:
                m = l[50:]
                m = l[:25]
                m = l[50:55]
                l[:3] = n
                m = l[:-1]
                m = l[1:]
                l[-1:] = n

if __name__ == '__main__':	
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)
	iterations = int(sys.argv[1])	
	arith = ArithmethicBenchmark(iterations)
	print (str(arith.run()))