import sys, time, operator, os
from time import clock
LOOPS = 5000

__version__ = "1.1"

[Ident1, Ident2, Ident3, Ident4, Ident5] = range(1, 6)

TRUE = 1
FALSE = 0


class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1
		
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)

class BenchMark:
	microSeconds = 0
	def __init__(self,iterations):		
		self.iterations = iterations
		
	
	def run(self):		
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
	
	def runOneIteration(self):
		pass	

class ArithmethicBenchmark(BenchMark):
	def __init__(self,iterations):
		self.iterations = iterations
		
	def runOneIteration(self):				
		chronometer = Chronometer()				
		pystone = Pystone()		
		chronometer.start()
		value = pystone.pystones(5000)
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()
		return value
		
class Record:
	def __init__(self, PtrComp = None, Discr = 0, EnumComp = 0,IntComp = 0, StringComp = 0):
		self.PtrComp = PtrComp
		self.Discr = Discr
		self.EnumComp = EnumComp
		self.IntComp = IntComp
		self.StringComp = StringComp

	def copy(self):
		return Record(self.PtrComp, self.Discr, self.EnumComp,self.IntComp, self.StringComp)

class Pystone:
	IntGlob = 0
	BoolGlob = FALSE
	Char1Glob = '\0'
	Char2Glob = '\0'
	Array1Glob = [0]*51
	Array2Glob = [x[:] for x in [Array1Glob]*51]
	PtrGlb = None
	PtrGlbNext = None	
	
	def pystones(self,loops=LOOPS):
		return self.Proc0(loops)

	def Proc0(self,loops=LOOPS):
		starttime = clock()
		for i in range(loops):
			pass
		nulltime = clock() - starttime

		Pystone.PtrGlbNext = Record()
		Pystone.PtrGlb = Record()
		Pystone.PtrGlb.PtrComp = Pystone.PtrGlbNext
		Pystone.PtrGlb.Discr = Ident1
		Pystone.PtrGlb.EnumComp = Ident3
		Pystone.PtrGlb.IntComp = 40
		Pystone.PtrGlb.StringComp = "DHRYSTONE PROGRAM, SOME STRING"	
		Pystone.Array2Glob[8][7] = 10
		starttime = clock()

		for i in range(loops):
			self.DoWork()

		benchtime = clock() - starttime - nulltime
		if benchtime == 0.0:
			loopsPerBenchtime = 0.0
		else:
			loopsPerBenchtime = (loops / benchtime)
		return benchtime, loopsPerBenchtime

	def DoWork(self):	
		self.Proc5()
		self.Proc4()
		IntLoc1 = 2
		IntLoc2 = 3
		String2Loc = "DHRYSTONE PROGRAM, 2'ND STRING"
		String1Loc = "DHRYSTONE PROGRAM, 1'ST STRING"
		EnumLoc = Ident2
		Pystone.BoolGlob = not self.Func2(String1Loc, String2Loc)
		while IntLoc1 < IntLoc2:
			IntLoc3 = 5 * IntLoc1 - IntLoc2
			IntLoc3 = self.Proc7(IntLoc1, IntLoc2)
			IntLoc1 = IntLoc1 + 1
		self.Proc8(Pystone.Array1Glob, Pystone.Array2Glob, IntLoc1, IntLoc3)
		Pystone.PtrGlb = self.Proc1(Pystone.PtrGlb)
		CharIndex = 'A'
		while CharIndex <= Pystone.Char2Glob:
			if EnumLoc == self.Func1(CharIndex, 'B'):
				EnumLoc = self.Proc6(Ident1)
			CharIndex = chr(ord(CharIndex)+1)
		IntLoc3 = IntLoc2 * IntLoc1
		IntLoc2 = IntLoc3 / IntLoc1
		IntLoc2 = 7 * (IntLoc3 - IntLoc2) - IntLoc1
		IntLoc1 = self.Proc2(IntLoc1)
	
	def Proc1(self,PtrParIn):
		PtrParIn.PtrComp = NextRecord = Pystone.PtrGlb.copy()
		PtrParIn.IntComp = 5
		NextRecord.IntComp = PtrParIn.IntComp
		NextRecord.PtrComp = PtrParIn.PtrComp
		NextRecord.PtrComp = self.Proc3(NextRecord.PtrComp)
		if NextRecord.Discr == Ident1:
			NextRecord.IntComp = 6
			NextRecord.EnumComp = self.Proc6(PtrParIn.EnumComp)
			NextRecord.PtrComp = self.PtrGlb.PtrComp
			NextRecord.IntComp = self.Proc7(NextRecord.IntComp, 10)
		else:
			PtrParIn = NextRecord.copy()
		NextRecord.PtrComp = None
		return PtrParIn

	def Proc2(self,IntParIO):
		IntLoc = IntParIO + 10
		while 1:
			if Pystone.Char1Glob == 'A':
				IntLoc = IntLoc - 1
				IntParIO = IntLoc - Pystone.IntGlob
				EnumLoc = Ident1
			if EnumLoc == Ident1:
				break
		return IntParIO

	def Proc3(self,PtrParOut):
		if Pystone.PtrGlb is not None:
			PtrParOut = Pystone.PtrGlb.PtrComp
		else:
			Pystone.IntGlob = 100
		Pystone.PtrGlb.IntComp = self.Proc7(10, Pystone.IntGlob)
		return PtrParOut

	def Proc4(self):
		BoolLoc = Pystone.Char1Glob == 'A'
		BoolLoc = BoolLoc or Pystone.BoolGlob
		Pystone.Char2Glob = 'B'

	def Proc5(self):
		Pystone.Char1Glob = 'A'
		Pystone.BoolGlob = FALSE

	def Proc6(self,EnumParIn):
		EnumParOut = EnumParIn
		if not self.Func3(EnumParIn):
			EnumParOut = Ident4
		if EnumParIn == Ident1:
			EnumParOut = Ident1
		elif EnumParIn == Ident2:
			if Pystone.IntGlob > 100:
				EnumParOut = Ident1
			else:
				EnumParOut = Ident4
		elif EnumParIn == Ident3:
			EnumParOut = Ident2
		elif EnumParIn == Ident4:
			pass
		elif EnumParIn == Ident5:
			EnumParOut = Ident3
		return EnumParOut

	def Proc7(self,IntParI1, IntParI2):
		IntLoc = IntParI1 + 2
		IntParOut = IntParI2 + IntLoc
		return IntParOut

	def Proc8(self,Array1Par, Array2Par, IntParI1, IntParI2):
		IntLoc = IntParI1 + 5
		Array1Par[IntLoc] = IntParI2
		Array1Par[IntLoc+1] = Array1Par[IntLoc]
		Array1Par[IntLoc+30] = IntLoc
		for IntIndex in range(IntLoc, IntLoc+2):
			Array2Par[IntLoc][IntIndex] = IntLoc
		Array2Par[IntLoc][IntLoc-1] = Array2Par[IntLoc][IntLoc-1] + 1
		Array2Par[IntLoc+20][IntLoc] = Array1Par[IntLoc]
		Pystone.IntGlob = 5

	def Func1(self,CharPar1, CharPar2):
		CharLoc1 = CharPar1
		CharLoc2 = CharLoc1
		if CharLoc2 != CharPar2:
			return Ident1
		else:
			return Ident2

	def Func2(self,StrParI1, StrParI2):
		IntLoc = 1
		while IntLoc <= 1:
			if self.Func1(StrParI1[IntLoc], StrParI2[IntLoc+1]) == Ident1:
				CharLoc = 'A'
				IntLoc = IntLoc + 1
		if CharLoc >= 'W' and CharLoc <= 'Z':
			IntLoc = 7
		if CharLoc == 'X':
			return TRUE
		else:
			if StrParI1 > StrParI2:
				IntLoc = IntLoc + 7
				return TRUE
			else:
				return FALSE

	def Func3(self,EnumParIn):
		EnumLoc = EnumParIn
		if EnumLoc == Ident3: return TRUE
		return FALSE

if __name__ == '__main__':	
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)
	iterations = int(sys.argv[1])	
	arith = ArithmethicBenchmark(iterations)
	print (str(arith.run()))