import sys, time, random, math
from time import clock
TRUE = 1
FALSE = 0

class NumericSortTest:
	def __init__(self):
		self.datasizes = {}
		self.datasizes[0] = 1000000
		self.datasizes[1] = 5000000
		self.datasizes[2] = 25000000
	
	def JGsetsize(self,size):
		self.size = size
		
	def JGinitialise(self):
		self.array_rows = self.datasizes[self.size]
		self.buildTestData()
			
	def JGFkernel(self):
		self.Do()
	
	def JGFvalidate(self):		
		error = FALSE
		i = 1
		while i < self.array_rows:
			error = self.TestArray[i] < self.TestArray[i - 1]
			if error:
				print ("Validation failed")
				print ("Item " + i + " = " + self.TestArray[i])
				print ("Item " + (i - 1) + " = " + self.TestArray[i - 1])
				pass
			i = i + 1
			
	def test(self):
		self.JGsetsize(0)
		self.JGinitialise()
		self.JGFkernel()
		self.JGFvalidate()
	
	def buildTestData(self):	
		self.TestArray = {}
		rndnum = random
		rndnum.seed(1729)
		i =	0
		while i < self.array_rows:
			self.TestArray[i] = rndnum.randint(0,2147483647)
			i = i + 1
	
	def Do(self):
		self.NumHeapSort()
	
	def NumSift(self,min ,max):
		while (min + min) <= max:
			inc = FALSE
			if (min + min) < max and self.TestArray[min + min] < self.TestArray[min + min + 1]:
				inc = TRUE
			k =  (min + min + 1 if inc else min + min)			
			if self.TestArray[min] < self.TestArray[k]:
				temp = self.TestArray[k]
				self.TestArray[k] = self.TestArray[min]
				self.TestArray[min] = temp
				min = k				
			else:
				min = max + 1

	def NumHeapSort(self):	
		top = self.array_rows - 1
		i = int(top / 2)		
		while i > 0:
			self.NumSift(i, top)
			i = i - 1
		i = top
		while i > 0:
			self.NumSift(0, i)
			temp = self.TestArray[0]
			self.TestArray[0] = self.TestArray[i]
			self.TestArray[i] = temp
			i = i - 1
	
class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1		
	def getMiliSeconds(self):
		return int(self.getSeconds() * 1000)
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)
	
class BenchMark:		
	def __init__(self,iterations):
		self.microSeconds = 0
		self.iterations = iterations

	def runOneIteration(self): 
		chronometer = Chronometer()							
		chronometer.start()				
		NumericSortTest().test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()		
		

	def run(self): 
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
		
if __name__ == '__main__':
	import sys
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)  
	iterations = int(sys.argv[1])
	bench = BenchMark(iterations)	
	print(str(int(bench.run())).replace(".",","))