function BenchMark(iterations) {
    this.microSeconds = 0;
	this.iterations = iterations;
}

BenchMark.prototype.runOneIteration = function() {		
	var before = new Date();
	new NestedForLoops().test();
	var after = new Date();	
	this.microSeconds =  this.microSeconds + ((after-before) * 1000);
}

BenchMark.prototype.run = function() {	
	for(var i = 0 ; i < this.iterations ; i++)
		this.runOneIteration();	
	return this.microSeconds;
}	

function NestedForLoops() {
    this.version = 2.0
    this.operations = 1000*10*5
    this.rounds = 300
}

NestedForLoops.prototype.test = function() {
	var l1 = range(1000)
	var l2 = range(10)
	var l3 = range(5)
	var l = 0
	for (var i in range(this.rounds))
		for (var i in l1)
			for (var j in l2)
				for (var k in l3)
					l = l + 1;	
}

function range(n) {
	var result = new Array();
	for(var i=0; i<n; i++)
		result[i] = i;
	return result;
}

if (scriptArgs.length == 1) {		
	var bench = new BenchMark(scriptArgs[0]);
	print(bench.run());
}
else {
	print("I need the name of the test.");
	quit();
}