function BenchMark(iterations) {
    this.microSeconds = 0;
	this.iterations = iterations;
}

BenchMark.prototype.runOneIteration = function() {		
	var before = new Date();
	new CreateInstances().test();
	var after = new Date();	
	this.microSeconds =  this.microSeconds + ((after-before) * 1000);
}

BenchMark.prototype.run = function() {	
	for(var i = 0 ; i < this.iterations ; i++)
		this.runOneIteration();	
	return this.microSeconds;
}	

function CreateInstances() {
	this.version = 2.0        
	this.rounds = 80000
}

function C() {
	this.a;
	this.b;
	this.c;
}

function D(a, b, c) {
	c = typeof c !== 'undefined' ? c : 30;
	this.a = a
	this.b = b
	this.c = c
}

function E(a, b, c) {
	c = typeof c !== 'undefined' ? c : 4;
	this.a = a
	this.b = b
	this.c = c
	this.d = a
	this.e = b
	this.f = c
}

CreateInstances.prototype.test = function() {
	var i = 0;				
	var three = 3;
	var four = 4;
	for(var i in range(this.rounds)) {
		var o = new C();
		var o1 = new C();
		var o2 = new C();
		var p = new D(i, i, three);
		var p1 = new D(i, i, three);
		var p2 = new D(i, three, three);
		var p3 = new D(three, i, three);
		var p4 = new D(i, i, i);
		var p5 = new D(three, i, three);
		var p6 = new D(i, i, i);
		var q = new E(i, i, three);
		var q1 = new E(i, i, three);
		var q2 = new E(i, i, three);                
		var q3 = new E(i, i, four);
	}
}

function range(n) {
	var result = new Array();
	for(var i=0; i<n; i++)
		result[i] = i;
	return result;
}

if (scriptArgs.length == 1) {		
	var bench = new BenchMark(scriptArgs[0]);
	print(bench.run());
}
else {
	print("I need the name of the test.");
	quit();
}