function NumericSortTest() { 
	this.datasizes = new Array(3);            
	this.datasizes[0] = 1000000;
	this.datasizes[1] = 5000000;
	this.datasizes[2] = 25000000;  	
}

NumericSortTest.prototype.buildTestData = function() {
	this.TestArray = new Array(this.array_rows);	
	var i = 0;
	while(i < this.array_rows)
	{
		this.TestArray[i] = getRandomInt(0,2147483647);		
		i = i + 1;
	}			
}	

function getRandomInt(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}

NumericSortTest.prototype.Do = function() {
	this.NumHeapSort();
}

NumericSortTest.prototype.NumSift = function(min,max) {
	while ((min + min) <= max)
	{                
		var inc = false;
		if ((min + min) < max && this.TestArray[min + min] < this.TestArray[min + min + 1])
			inc = true;
		var k = inc ? min + min + 1 : min + min;                
		if (this.TestArray[min] < this.TestArray[k])
		{                   
			var temp = this.TestArray[k];
			this.TestArray[k] = this.TestArray[min];
			this.TestArray[min] = temp;                 
			min = k;                    
		}
		else
			min = max + 1;
	}		
}

NumericSortTest.prototype.NumHeapSort = function() {
	var temp; 						
	var top = this.array_rows - 1;			
	var i = Math.floor(top / 2);
	while( i > 0)
	{								
		this.NumSift(i, top);
		i = i - 1;
	}	
	i = top;
	while( i > 0)
	{
		this.NumSift(0, i);
		temp = this.TestArray[0];
		this.TestArray[0] = this.TestArray[i];
		this.TestArray[i] = temp;
		i = i - 1;
	}			
}

NumericSortTest.prototype.JGFsetsize = function(size) {
	this.size = size;
}		

NumericSortTest.prototype.JGFinitialise = function() {
	this.array_rows = this.datasizes[this.size];
    this.buildTestData();
}		

NumericSortTest.prototype.JGFkernel = function() {
	this.Do();
}

NumericSortTest.prototype.JGFvalidate = function() {
	var error = false;
	var i = 1;
	while (i < this.array_rows)
	{
		error = (this.TestArray[i] < this.TestArray[i - 1]);				
		if (error)
		{
			print("Validation failed");
			print("Item " + i + " = " + this.TestArray[i]);
			print("Item " + (i - 1) + " = " + this.TestArray[i - 1]);					
			break;
		}
		i = i + 1;
	}	
}

NumericSortTest.prototype.test = function() {
	this.JGFsetsize(0);
	this.JGFinitialise();
	this.JGFkernel();
	this.JGFvalidate();   	
}

function BenchMark(iterations) {
    this.microSeconds = 0;
	this.iterations = iterations;
}

BenchMark.prototype.runOneIteration = function() {		
	var before = new Date();
	new NumericSortTest().test();
	var after = new Date();	
	this.microSeconds =  this.microSeconds + ((after-before) * 1000);
}

BenchMark.prototype.run = function() {	
	for(var i = 0 ; i < this.iterations ; i++)
		this.runOneIteration();	
	return this.microSeconds;
}	

function range(n) {
	var result = new Array();
	for(var i=0; i<n; i++)
		result[i] = i;
	return result;
}

if (arguments.length == 1) {		
	var bench = new BenchMark(arguments[0]);
	print(bench.run());
}
else {
	print("I need the name of the test.");
	quit();
}