function BenchMark(iterations) {
    this.microSeconds = 0;
	this.iterations = iterations;
}

BenchMark.prototype.runOneIteration = function() {		
	var before = new Date();
	new FunctionCalls().test();
	var after = new Date();
	this.microSeconds =  this.microSeconds + ((after-before) * 1000);
}

BenchMark.prototype.run = function() {	
	for(var i = 0 ; i < this.iterations ; i++)
		this.runOneIteration();	
	return this.microSeconds;
}

function global_f() {
    return this.toString();
}

function global_f1(x) {
    return x * x * x;
}

function global_g(a, b, c) {
    return a * b * c;
}

function global_h(a, b, c, d, e, f) {
    return a * b * c * d * e * f;
}

function FunctionCalls() {
    this.a = 0;
    this.version = 2.0;
    this.operations = 5*(1+4+4+2);
    this.rounds = 60000;
}

FunctionCalls.prototype.test = function() {
        
        FunctionCalls.prototype.f = global_f;
        FunctionCalls.prototype.f1 = global_f1;
        FunctionCalls.prototype.g = global_g;
        FunctionCalls.prototype.h = global_h;


        for(var i in range(this.rounds)) {
            this.f()
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.h(i,i,3,i,i,3)
            this.h(i,i,i,2,i,3)

            this.f()
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.h(i,i,3,i,i,3)
            this.h(i,i,i,2,i,3)

            this.f()
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.h(i,i,3,i,i,3)
            this.h(i,i,i,2,i,3)

            this.f()
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.h(i,i,3,i,i,3)
            this.h(i,i,i,2,i,3)

            this.f()
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.f1(i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.g(i,i,i)
            this.h(i,i,3,i,i,3)
            this.h(i,i,i,2,i,3)
		}
}

function range(n) {
	var result = new Array();
	for(var i=0; i<n; i++)
		result[i] = i;
	return result;
}

if (arguments.length == 1) {		
	var bench = new BenchMark(arguments[0]);
	print(bench.run());
}
else {
	print("I need the name of the test.");
	quit();
}