function BenchMark(iterations) {
    this.microSeconds = 0;
	this.iterations = iterations;
}

BenchMark.prototype.runOneIteration = function() {		
	var before = new Date();
	new Recursion().test();
	var after = new Date();
	this.microSeconds =  this.microSeconds + ((after-before) * 1000);
}

BenchMark.prototype.run = function() {	
	for(var i = 0 ; i < this.iterations ; i++)
		this.runOneIteration();	
	return this.microSeconds;
}

function Recursion() {
    this.version = 2.0
    this.operations = 5
    this.rounds = 100000
}

Recursion.prototype.f = function(x) {
	if (x > 1){
		return this.f(x - 1);
	}
	return 1;
}

Recursion.prototype.test = function() {    
	for (var i in range(this.rounds)) {
		this.f(10)
		this.f(10)
		this.f(10)
		this.f(10)
		this.f(10)
	}
}

function range(n) {
	var result = new Array();
	for(var i=0; i<n; i++)
		result[i] = i;
	return result;
}

if (arguments.length == 1) {		
	var bench = new BenchMark(arguments[0]);
	print(bench.run());
}
else {
	print("I need the name of the test.");
	quit();
}