function Node (data, next) {		
	this.data = data;
	this.next = next;		
}
	
function Point3D(x, y, z, dimensions) {
	this.x = x;
	this.y = y;
	this.z = z;	
	this.dimensions = dimensions;					
}
	
function Point2D(x, y,dimensions) {
	this.x = x;
	this.y = y;			
	this.dimensions = dimensions;
}

function PointsBench() {    
}

PointsBench.prototype.createPoint = function(dimensions, x, y, z) {
	var point;
	if (dimensions==2)
		point = new Point2D(x,y,dimensions);
	else
		point = new Point3D(x,y,z,3);
	return point;
}

PointsBench.prototype.createPoints = function(number) {
	var i;
	var list, point;

	i = 1;
	point = this.createPoint(3,0,0,0);
	list = new Node(point, 0); 
	while(i < number) 
	{
		point = this.createPoint(i % 2 + 2, number/2 - i, i, i);
		list = new Node(point, list);
		i = i + 1;
	}
	return list;
}

PointsBench.prototype.positiveX = function(list, n) {
	var i;
	var l, result;
	result = 0;
	i = 0;
	l = list;
	while(i < n)
	{
		if(l.data.x >= 0)
			result = new Node(l.data,result);
		l = l.next;
		i = i + 1;
	}
	return result;
}
	
PointsBench.prototype.distance3D = function(point) {		
	var value;
	value = 2147483647;				
	if (point.dimensions == 3)
		value = point.x*point.x + point.y*point.y + point.z*point.z;
	return value;
}	

PointsBench.prototype.closestToOrigin3D = function(list, n) {
	var i, minDistance;
	var l, point3D;
	
	point3D = this.createPoint(3,0,0,0);
	minDistance = 2147483647;
	l = list;
	i = 0;
	while(i<n) {  
		if(this.distance3D(l.data)<minDistance) 
		{
			minDistance = this.distance3D(l.data);
			point3D = l.data;
		}
		l = l.next;
		i = i + 1;
	}	
	return point3D;  
}
		

PointsBench.prototype.test = function() {
	var numberOfPoints;
	var list, positive, point;					
	numberOfPoints = 10000;
	list = this.createPoints(numberOfPoints);
	positive = this.positiveX(list, numberOfPoints);  
	point = this.closestToOrigin3D(list, numberOfPoints);
}


function BenchMark(iterations) {
    this.microSeconds = 0;
	this.iterations = iterations;
}

BenchMark.prototype.runOneIteration = function() {		
	var before = new Date();
	new PointsBench().test();
	var after = new Date();	
	this.microSeconds =  this.microSeconds + ((after-before) * 1000);
}

BenchMark.prototype.run = function() {	
	for(var i = 0 ; i < this.iterations ; i++)
		this.runOneIteration();	
	return this.microSeconds;
}	

function range(n) {
	var result = new Array();
	for(var i=0; i<n; i++)
		result[i] = i;
	return result;
}

if (arguments.length == 1) {		
	var bench = new BenchMark(arguments[0]);
	print(bench.run());
}
else {
	print("I need the name of the test.");
	quit();
}