Namespace Pybench.Aritmethic
	Public Class Chronometer
		Private ticks1 As DateTime, ticks2 As DateTime
		Private stopped As Boolean

		Public Sub Start()
			ticks1 = DateTime.Now
			stopped = False
		End Sub
		Public Sub [Stop]()
			ticks2 = DateTime.Now
			stopped = True
		End Sub

		Private Shared Function TicksToMicroSeconds(t1 As DateTime, t2 As DateTime) As Integer
			Return TicksToMiliSeconds(t1, t2) * 1000
		End Function

		Private Shared Function TicksToMiliSeconds(t1 As DateTime, t2 As DateTime) As Integer
			Dim difference As TimeSpan = t2.Subtract(t1)
			Return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000)
		End Function

		Private Shared Function TicksToSeconds(t1 As DateTime, t2 As DateTime) As Integer
			Dim difference As TimeSpan = t2.Subtract(t1)
			Return (difference.Seconds + difference.Minutes * 60)
		End Function

		Public Function GetMicroSeconds() As Integer
			If stopped Then
				Return TicksToMicroSeconds(ticks1, ticks2)
			End If
			Return TicksToMicroSeconds(ticks1, DateTime.Now)
		End Function

		Public Function GetMiliSeconds() As Integer
			If stopped Then
				Return TicksToMiliSeconds(ticks1, ticks2)
			End If
			Return TicksToMiliSeconds(ticks1, DateTime.Now)
		End Function

		Public Function GetSeconds() As Integer
			If stopped Then
				Return TicksToSeconds(ticks1, ticks2)
			End If
			Return TicksToSeconds(ticks1, DateTime.Now)
		End Function
	End Class

	Public Class BenchMark
		Private iterations As Integer
		Protected microSeconds As Integer

		Public Sub New(iterations As Integer)
			Me.iterations = iterations
		End Sub

		Public Function run() As Integer
			Dim self As BenchMark = Me
			For i As Integer = 0 To iterations - 1
				self.runOneIteration()
			Next
			Return Me.microSeconds
		End Function

		Public Overridable Function runOneIteration() As Object
			Return Nothing
		End Function
	End Class

	Public Class ArithmethicBenchmark
		Inherits BenchMark
		Public Sub New(iterations As Integer)
			MyBase.New(iterations)
		End Sub
		Public Overrides Function runOneIteration() As Object
			Dim chronometer As New Chronometer()
			Dim test As Test = New DictCreation()
			chronometer.Start()
			test.test()
			chronometer.[Stop]()
			Me.microSeconds = Me.microSeconds + chronometer.GetMicroSeconds()
			Return Nothing
		End Function
	End Class

	Public MustInherit Class Test
		Public MustOverride Sub test()
	End Class

	Public Class DictCreation
		Inherits Test
		Public Overrides Sub test()
			Dim i 
			i = 0
			Dim two			
			Dim three
			Dim four
			Dim five
			Dim six
			Dim seven
			Dim eight
			Dim nine
			Dim ten
			Dim eleven
			
			two = 2
			three = 3
			four = 4
			five = 5
			six = 6
			seven = 7
			eight = 8
			nine = 9
			ten = 10
			eleven = 11

			While i < 80000
				Dim d1 
				Dim d2 
				Dim d3 
				Dim d4 
				Dim d5 
				
				d1 = New Object(10) {}
				d2 = New Object(10) {}
				d3 = New Object(10) {}
				d4 = New Object(10) {}
				d5 = New Object(10) {}
				
				d1(1) = two
				d1(3) = four
				d1(5) = six

				d2(2) = three
				d2(4) = five
				d2(6) = seven

				d3(3) = four
				d3(5) = six
				d3(7) = eight

				d4(4) = five
				d4(6) = seven
				d4(8) = nine

				d5(6) = seven
				d5(8) = nine
				d5(10) = eleven

				d1 = New Object(10) {}
				d2 = New Object(10) {}
				d3 = New Object(10) {}
				d4 = New Object(10) {}
				d5 = New Object(10) {}

				d1(1) = two
				d1(3) = four
				d1(5) = six

				d2(2) = three
				d2(4) = five
				d2(6) = seven

				d3(3) = four
				d3(5) = six
				d3(7) = eight

				d4(4) = five
				d4(6) = seven
				d4(8) = nine

				d5(6) = seven
				d5(8) = nine
				d5(10) = eleven

				d1 = New Object(10) {}
				d2 = New Object(10) {}
				d3 = New Object(10) {}
				d4 = New Object(10) {}
				d5 = New Object(10) {}

				d1(1) = two
				d1(3) = four
				d1(5) = six

				d2(2) = three
				d2(4) = five
				d2(6) = seven

				d3(3) = four
				d3(5) = six
				d3(7) = eight

				d4(4) = five
				d4(6) = seven
				d4(8) = nine

				d5(6) = seven
				d5(8) = nine
				d5(10) = eleven

				d1 = New Object(10) {}
				d2 = New Object(10) {}
				d3 = New Object(10) {}
				d4 = New Object(10) {}
				d5 = New Object(10) {}

				d1(1) = two
				d1(3) = four
				d1(5) = six

				d2(2) = three
				d2(4) = five
				d2(6) = seven

				d3(3) = four
				d3(5) = six
				d3(7) = eight

				d4(4) = five
				d4(6) = seven
				d4(8) = nine

				d5(6) = seven
				d5(8) = nine
				d5(10) = eleven

				d1 = New Object(10) {}
				d2 = New Object(10) {}
				d3 = New Object(10) {}
				d4 = New Object(10) {}
				d5 = New Object(10) {}

				d1(1) = two
				d1(3) = four
				d1(5) = six

				d2(2) = three
				d2(4) = five
				d2(6) = seven

				d3(3) = four
				d3(5) = six
				d3(7) = eight

				d4(4) = five
				d4(6) = seven
				d4(8) = nine

				d5(6) = seven
				d5(8) = nine
				d5(10) = eleven

				i = i + 1
			End While
		End Sub
	End Class

	Public Class Program
		Public Shared Sub Main(args As String())
			If args.Length < 1 Then
				Console.[Error].WriteLine("You must pass the number of thousands iterations.")
				System.Environment.[Exit](-1)
			End If
			Dim iterations As Integer = Convert.ToInt32(args(0))
			Dim arith As New ArithmethicBenchmark(iterations)
			Console.WriteLine(arith.run())
		End Sub
	End Class
End Namespace
