Namespace Pybench.Aritmethic
	Public Class Chronometer
		Private ticks1 As DateTime, ticks2 As DateTime
		Private stopped As Boolean

		Public Sub Start()
			ticks1 = DateTime.Now
			stopped = False
		End Sub
		Public Sub [Stop]()
			ticks2 = DateTime.Now
			stopped = True
		End Sub

		Private Shared Function TicksToMicroSeconds(t1 As DateTime, t2 As DateTime) As Integer
			Return TicksToMiliSeconds(t1, t2) * 1000
		End Function

		Private Shared Function TicksToMiliSeconds(t1 As DateTime, t2 As DateTime) As Integer
			Dim difference As TimeSpan = t2.Subtract(t1)
			Return (difference.Milliseconds + difference.Seconds * 1000 + difference.Minutes * 60000)
		End Function

		Private Shared Function TicksToSeconds(t1 As DateTime, t2 As DateTime) As Integer
			Dim difference As TimeSpan = t2.Subtract(t1)
			Return (difference.Seconds + difference.Minutes * 60)
		End Function

		Public Function GetMicroSeconds() As Integer
			If stopped Then
				Return TicksToMicroSeconds(ticks1, ticks2)
			End If
			Return TicksToMicroSeconds(ticks1, DateTime.Now)
		End Function

		Public Function GetMiliSeconds() As Integer
			If stopped Then
				Return TicksToMiliSeconds(ticks1, ticks2)
			End If
			Return TicksToMiliSeconds(ticks1, DateTime.Now)
		End Function

		Public Function GetSeconds() As Integer
			If stopped Then
				Return TicksToSeconds(ticks1, ticks2)
			End If
			Return TicksToSeconds(ticks1, DateTime.Now)
		End Function
	End Class

	Public Class BenchMark
		Private iterations As Integer
		Protected microSeconds As Integer

		Public Sub New(iterations As Integer)
			Me.iterations = iterations
		End Sub

		Public Function run() As Integer
			Dim self As BenchMark = Me
			For i As Integer = 0 To iterations - 1
				self.runOneIteration()
			Next
			Return Me.microSeconds
		End Function

		Public Overridable Function runOneIteration() As Object
			Return Nothing
		End Function
	End Class

	Public Class ArithmethicBenchmark
		Inherits BenchMark
		Public Sub New(iterations As Integer)
			MyBase.New(iterations)
		End Sub
		Public Overrides Function runOneIteration() As Object
			Dim chronometer As New Chronometer()
			Dim test As Test = New TryExcept()
			chronometer.Start()
			test.test()
			chronometer.[Stop]()
			Me.microSeconds = Me.microSeconds + chronometer.GetMicroSeconds()
			Return Nothing
		End Function
	End Class

	Public MustInherit Class Test
		Public MustOverride Sub test()
	End Class

	Public Class TryExcept
		Inherits Test
		Public Overrides Sub test()
			Dim i
			i = 0
			Dim temp
			While i < 150000
				Try 
					temp = i
				Catch ex0 As Exception
				End Try
				Try
					temp = i
				Catch ex1 As Exception
				End Try
				Try
					temp = i
				Catch ex2 As Exception
				End Try
				Try
					temp = i
				Catch ex3 As Exception
				End Try
				Try
					temp = i
				Catch ex4 As Exception
				End Try
				Try
					temp = i
				Catch ex5 As Exception
				End Try
				Try
					temp = i
				Catch ex6 As Exception
				End Try
				Try
					temp = i
				Catch ex7 As Exception
				End Try
				Try
					temp = i
				Catch ex8 As Exception
				End Try
				Try
					temp = i
				Catch ex9 As Exception
				End Try

				Try
					temp = i
				Catch ex10 As Exception
				End Try
				Try
					temp = i
				Catch ex11 As Exception
				End Try
				Try
					temp = i
				Catch ex12 As Exception
				End Try
				Try
					temp = i
				Catch ex13 As Exception
				End Try
				Try
					temp = i
				Catch ex14 As Exception
				End Try
				Try
					temp = i
				Catch ex15 As Exception
				End Try
				Try
					temp = i
				Catch ex16 As Exception
				End Try
				Try
					temp = i
				Catch ex17 As Exception
				End Try
				Try
					temp = i
				Catch ex18 As Exception
				End Try
				Try
					temp = i
				Catch ex19 As Exception
				End Try

				Try
					temp = i
				Catch ex20 As Exception
				End Try
				Try
					temp = i
				Catch ex21 As Exception
				End Try
				Try
					temp = i
				Catch ex22 As Exception
				End Try
				Try
					temp = i
				Catch ex23 As Exception
				End Try
				Try
					temp = i
				Catch ex24 As Exception
				End Try
				Try
					temp = i
				Catch ex25 As Exception
				End Try
				Try
					temp = i
				Catch ex26 As Exception
				End Try
				Try
					temp = i
				Catch ex27 As Exception
				End Try
				Try
					temp = i
				Catch ex28 As Exception
				End Try
				Try
					temp = i
				Catch ex29 As Exception
				End Try

				Try
					temp = i
				Catch ex30 As Exception
				End Try
				Try
					temp = i
				Catch ex31 As Exception
				End Try
				Try
					temp = i
				Catch ex32 As Exception
				End Try
				Try
					temp = i
				Catch ex33 As Exception
				End Try
				Try
					temp = i
				Catch ex34 As Exception
				End Try
				Try
					temp = i
				Catch ex35 As Exception
				End Try
				Try
					temp = i
				Catch ex36 As Exception
				End Try
				Try
					temp = i
				Catch ex37 As Exception
				End Try
				Try
					temp = i
				Catch ex38 As Exception
				End Try
				Try
					temp = i
				Catch ex39 As Exception
				End Try

				Try
					temp = i
				Catch ex40 As Exception
				End Try
				Try
					temp = i
				Catch ex41 As Exception
				End Try
				Try
					temp = i
				Catch ex42 As Exception
				End Try
				Try
					temp = i
				Catch ex43 As Exception
				End Try
				Try
					temp = i
				Catch ex44 As Exception
				End Try
				Try
					temp = i
				Catch ex45 As Exception
				End Try
				Try
					temp = i
				Catch ex46 As Exception
				End Try
				Try
					temp = i
				Catch ex47 As Exception
				End Try
				Try
					temp = i
				Catch ex48 As Exception
				End Try
				Try
					temp = i
				Catch ex49 As Exception
				End Try

				Try
					temp = i
				Catch ex50 As Exception
				End Try
				Try
					temp = i
				Catch ex51 As Exception
				End Try
				Try
					temp = i
				Catch ex52 As Exception
				End Try
				Try
					temp = i
				Catch ex53 As Exception
				End Try
				Try
					temp = i
				Catch ex54 As Exception
				End Try
				Try
					temp = i
				Catch ex55 As Exception
				End Try
				Try
					temp = i
				Catch ex56 As Exception
				End Try
				Try
					temp = i
				Catch ex57 As Exception
				End Try
				Try
					temp = i
				Catch ex58 As Exception
				End Try
				Try
					temp = i
				Catch ex59 As Exception
				End Try

				Try
					temp = i
				Catch ex60 As Exception
				End Try
				Try
					temp = i
				Catch ex61 As Exception
				End Try
				Try
					temp = i
				Catch ex62 As Exception
				End Try
				Try
					temp = i
				Catch ex63 As Exception
				End Try
				Try
					temp = i
				Catch ex64 As Exception
				End Try
				Try
					temp = i
				Catch ex65 As Exception
				End Try
				Try
					temp = i
				Catch ex66 As Exception
				End Try
				Try
					temp = i
				Catch ex67 As Exception
				End Try
				Try
					temp = i
				Catch ex68 As Exception
				End Try
				Try
					temp = i
				Catch ex69 As Exception
				End Try

				Try
					temp = i
				Catch ex70 As Exception
				End Try
				Try
					temp = i
				Catch ex71 As Exception
				End Try
				Try
					temp = i
				Catch ex72 As Exception
				End Try
				Try
					temp = i
				Catch ex73 As Exception
				End Try
				Try
					temp = i
				Catch ex74 As Exception
				End Try
				Try
					temp = i
				Catch ex75 As Exception
				End Try
				Try
					temp = i
				Catch ex76 As Exception
				End Try
				Try
					temp = i
				Catch ex77 As Exception
				End Try
				Try
					temp = i
				Catch ex78 As Exception
				End Try
				Try
					temp = i
				Catch ex79 As Exception
				End Try

				Try
					temp = i
				Catch ex80 As Exception
				End Try
				Try
					temp = i
				Catch ex81 As Exception
				End Try
				Try
					temp = i
				Catch ex82 As Exception
				End Try
				Try
					temp = i
				Catch ex83 As Exception
				End Try
				Try
					temp = i
				Catch ex84 As Exception
				End Try
				Try
					temp = i
				Catch ex85 As Exception
				End Try
				Try
					temp = i
				Catch ex86 As Exception
				End Try
				Try
					temp = i
				Catch ex87 As Exception
				End Try
				Try
					temp = i
				Catch ex88 As Exception
				End Try
				Try
					temp = i
				Catch ex89 As Exception
				End Try

				Try
					temp = i
				Catch ex90 As Exception
				End Try
				Try
					temp = i
				Catch ex91 As Exception
				End Try
				Try
					temp = i
				Catch ex92 As Exception
				End Try
				Try
					temp = i
				Catch ex93 As Exception
				End Try
				Try
					temp = i
				Catch ex94 As Exception
				End Try
				Try
					temp = i
				Catch ex95 As Exception
				End Try
				Try
					temp = i
				Catch ex96 As Exception
				End Try
				Try
					temp = i
				Catch ex97 As Exception
				End Try
				Try
					temp = i
				Catch ex98 As Exception
				End Try
				Try
					temp = i
				Catch ex99 As Exception
				End Try

				Try
					temp = i
				Catch ex100 As Exception
				End Try
				Try
					temp = i
				Catch ex101 As Exception
				End Try
				Try
					temp = i
				Catch ex102 As Exception
				End Try
				Try
					temp = i
				Catch ex103 As Exception
				End Try
				Try
					temp = i
				Catch ex104 As Exception
				End Try
				Try
					temp = i
				Catch ex105 As Exception
				End Try
				Try
					temp = i
				Catch ex106 As Exception
				End Try
				Try
					temp = i
				Catch ex107 As Exception
				End Try
				Try
					temp = i
				Catch ex108 As Exception
				End Try
				Try
					temp = i
				Catch ex109 As Exception
				End Try

				Try
					temp = i
				Catch ex110 As Exception
				End Try
				Try
					temp = i
				Catch ex111 As Exception
				End Try
				Try
					temp = i
				Catch ex112 As Exception
				End Try
				Try
					temp = i
				Catch ex113 As Exception
				End Try
				Try
					temp = i
				Catch ex114 As Exception
				End Try
				Try
					temp = i
				Catch ex115 As Exception
				End Try
				Try
					temp = i
				Catch ex116 As Exception
				End Try
				Try
					temp = i
				Catch ex117 As Exception
				End Try
				Try
					temp = i
				Catch ex118 As Exception
				End Try
				Try
					temp = i
				Catch ex119 As Exception
				End Try

				Try
					temp = i
				Catch ex120 As Exception
				End Try
				Try
					temp = i
				Catch ex121 As Exception
				End Try
				Try
					temp = i
				Catch ex122 As Exception
				End Try
				Try
					temp = i
				Catch ex123 As Exception
				End Try
				Try
					temp = i
				Catch ex124 As Exception
				End Try
				Try
					temp = i
				Catch ex125 As Exception
				End Try
				Try
					temp = i
				Catch ex126 As Exception
				End Try
				Try
					temp = i
				Catch ex127 As Exception
				End Try
				Try
					temp = i
				Catch ex128 As Exception
				End Try
				Try
					temp = i
				Catch ex129 As Exception
				End Try

				Try
					temp = i
				Catch ex130 As Exception
				End Try
				Try
					temp = i
				Catch ex131 As Exception
				End Try
				Try
					temp = i
				Catch ex132 As Exception
				End Try
				Try
					temp = i
				Catch ex133 As Exception
				End Try
				Try
					temp = i
				Catch ex134 As Exception
				End Try
				Try
					temp = i
				Catch ex135 As Exception
				End Try
				Try
					temp = i
				Catch ex136 As Exception
				End Try
				Try
					temp = i
				Catch ex137 As Exception
				End Try
				Try
					temp = i
				Catch ex138 As Exception
				End Try
				Try
					temp = i
				Catch ex139 As Exception
				End Try

				Try
					temp = i
				Catch ex140 As Exception
				End Try
				Try
					temp = i
				Catch ex141 As Exception
				End Try
				Try
					temp = i
				Catch ex142 As Exception
				End Try
				Try
					temp = i
				Catch ex143 As Exception
				End Try
				Try
					temp = i
				Catch ex144 As Exception
				End Try
				Try
					temp = i
				Catch ex145 As Exception
				End Try
				Try
					temp = i
				Catch ex146 As Exception
				End Try
				Try
					temp = i
				Catch ex147 As Exception
				End Try
				Try
					temp = i
				Catch ex148 As Exception
				End Try
				Try
					temp = i
				Catch ex149 As Exception
				End Try

				i = i + 1
			End While
		End Sub
	End Class

	Public Class Program
		Public Shared Sub Main(args As String())
			If args.Length < 1 Then
				Console.[Error].WriteLine("You must pass the number of thousands iterations.")
				System.Environment.[Exit](-1)
			End If
			Dim iterations As Integer = Convert.ToInt32(args(0))
			Dim arith As New ArithmethicBenchmark(iterations)
			Console.WriteLine(arith.run())
		End Sub
	End Class
End Namespace
