import sys, time, random, math
from time import clock
TRUE = 1
FALSE = 0

class JGFFTBench:
	JDKtotal = 0.0
	JDKtotali = 0.0

	def JGFkernel(self,datasizes,size):
		R = random
		x = JGFFTBench.RandomVector(2 * datasizes[size], R)
		JGFFTBench.transform(x)
		JGFFTBench.inverse(x) 
	
	def JGFvalidate(self,size):
		refval =  {}
		refval[0] = 1.726962988395339
		refval[1] = 6.907851953579193
		refval[2] = 13.815703907167297
		refvali =  {}
		refvali[0] = 2.0974756152524314
		refvali[1] = 8.389142211032294
		refvali[2] = 16.778094422092604
		dev = JGFFTBench.JDKtotal - refval[size]
		dev = (dev if dev >= 0 else -1 * dev)
		if dev > 0.000000000001:
			#print ("Validation failed")
			#print ("JDKtotal = " + str(JGFFTBench.JDKtotal) + "  " + str(dev) + "  " + str(size))
			pass
		devi = JGFFTBench.JDKtotali - refvali[size]
		devi = (devi if devi >= 0 else -1 * devi)
		if dev > 0.000000000001:
			#print ("Validation failed")
			#print ("JDKtotali = " + str(JGFFTBench.JDKtotali) + "  " + str(devi) + "  " + str(size))
			pass
			
	def test(self):
		datasizes =  {}
		datasizes[0] = 65536
		datasizes[1] = 8388608
		datasizes[2] = 16777216
		size = 0
		self.JGFkernel(datasizes,size)
		self.JGFvalidate(size)
	
	@staticmethod
	def RandomVector(N,R):
		a =  {}
		for i in range(N):
			a[i] = R.random() * 0.000001
		return a
	
	@staticmethod
	def log2(n):
		log = 0
		k = 1
		while k < n:
			k = k * 2
			log = log + 1
		if n != (1 << log):
			print ("FFT: Data Length is not a power of 2!: " + n.ToString())
		return log
	
	@staticmethod
	def makeRandom(n):
		rand = random
		nd = 2 * n
		data =  {}
		for i in range(nd):
			data[i] = rand.random()
		return data
	
	@staticmethod	
	def bitreverse(data):
		n = len(data) / 2
		j = 0
		i = 0
		while i < (n - 1):
			ii = 2 * i
			jj = 2 * j
			k = n / 2
			if i < j:
				tmp_real = data[ii]
				tmp_imag = data[ii + 1]
				data[ii] = data[jj]
				data[ii + 1] = data[jj + 1]
				data[jj] = tmp_real
				data[jj + 1] = tmp_imag
			while k <= j:
				j = j - k
				k = k / 2
			j = j + k
			i = i + 1
	
	@staticmethod
	def transform_internal(data, direction):
		n = len(data) / 2
		if n == 1: 
			return
		logn = JGFFTBench.log2(n)
		JGFFTBench.bitreverse(data)
		dual = 1
		bit = 0
		while bit < logn:
			w_real = 1.0
			w_imag = 0.0
			theta = 2.0 * direction * 3.14159265 / (2.0 * dual)
			s = math.sin(theta)
			t = math.sin(theta / 2.0)
			s2 = 2.0 * t * t			
			iterations = 0
			while iterations < n:
				i = 2 * iterations
				j = 2 * (iterations + dual)
				wd_real = data[j]
				wd_imag = data[j + 1]
				data[j] = data[i] - wd_real
				data[j + 1] = data[i + 1] - wd_imag
				data[i] = data[i] + wd_real
				data[i + 1] = data[i + 1] + wd_imag
				iterations = iterations + (2*dual)
			iterations = 1
			while iterations < dual:
				tmp_real = w_real - s * w_imag - s2 * w_real
				tmp_imag = w_imag + s * w_real - s2 * w_imag
				w_real = tmp_real
				w_imag = tmp_imag
				b = 0
				while b < n:
					i = 2 * (b + iterations)
					j = 2 * (b + iterations + dual)
					z1_real = data[j]
					z1_imag = data[j + 1]
					wd_real = w_real * z1_real - w_imag * z1_imag
					wd_imag = w_real * z1_imag + w_imag * z1_real
					data[j] = data[i] - wd_real
					data[j + 1] = data[i + 1] - wd_imag
					data[i] = data[i] + wd_real
					data[i + 1] = data[i + 1] + wd_imag
					b = b + (2 * dual)
				iterations = iterations + 1
			dual = dual * 2
			bit = bit + 1
	
	@staticmethod
	def transform(data):
		JGFFTBench.transform_internal(data, -1)
		JDKrange = len(data)
		for i in range(JDKrange):
			JGFFTBench.JDKtotal = JGFFTBench.JDKtotal + data[i]
	
	@staticmethod
	def inverse(data):		
		JGFFTBench.transform_internal(data, 1)
		nd = len(data)
		n = nd / 2.0
		norm = 1 / n				
		for i in range(nd):
			data[i] = data[i] * norm
		for i in range(nd):			
			JGFFTBench.JDKtotali = JGFFTBench.JDKtotali + data[i]
	
class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1		
	def getMiliSeconds(self):
		return int(self.getSeconds() * 1000)
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)
	
class BenchMark:		
	def __init__(self,iterations):
		self.microSeconds = 0
		self.iterations = iterations

	def runOneIteration(self): 
		chronometer = Chronometer()							
		chronometer.start()				
		JGFFTBench().test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()		
		

	def run(self): 
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
		
if __name__ == '__main__':
	import sys
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)  
	iterations = int(sys.argv[1])
	bench = BenchMark(iterations)	
	print(str(int(bench.run())).replace(".",","))