import sys, time, random, math
from time import clock
TRUE = 1
FALSE = 0

class NumericSortTest:
	def NumSift(self,TestArray,min ,max):
		while (min + min) <= max:
			inc = FALSE
			if (min + min) < max and TestArray[min + min] < TestArray[min + min + 1]:
				inc = TRUE
			k =  (min + min + 1 if inc else min + min)			
			if TestArray[min] < TestArray[k]:
				temp = TestArray[k]
				TestArray[k] = TestArray[min]
				TestArray[min] = temp
				min = k				
			else:
				min = max + 1		
	
	def JGFkernel(self,TestArray,array_rows):
		top = array_rows - 1
		i = int(top / 2)		
		while i > 0:
			self.NumSift(TestArray,i, top)
			i = i - 1
		i = top
		while i > 0:
			self.NumSift(TestArray,0, i)
			temp = TestArray[0]
			TestArray[0] = TestArray[i]
			TestArray[i] = temp
			i = i - 1
	
	def JGFvalidate(self,TestArray,array_rows):		
		error = FALSE
		i = 1
		while i < array_rows:
			error = TestArray[i] < TestArray[i - 1]
			if error:
				print ("Validation failed")
				print ("Item " + i + " = " + TestArray[i])
				print ("Item " + (i - 1) + " = " + TestArray[i - 1])
				pass
			i = i + 1
			
	def test(self):
		size = 0

		datasizes = {}
		datasizes[0] = 1000000
		datasizes[1] = 5000000
		datasizes[2] = 25000000
		
		array_rows = datasizes[size]
		TestArray = {}
		rndnum = random
		rndnum.seed(1729)
		i =	0
		while i < array_rows:
			TestArray[i] = rndnum.randint(0,2147483647)
			i = i + 1		
		self.JGFkernel(TestArray,array_rows)
		self.JGFvalidate(TestArray,array_rows)	
		
class Chronometer:
	ticks1 = 0
	ticks2 = 0
	stopped = TRUE
	
	def start(self):
		self.ticks1 = time.time()
		self.stopped = FALSE

	def stop(self):
		self.ticks2 = time.time()
		self.stopped = TRUE

	def getSeconds(self):
		if self.stopped:
			return self.ticks2 - self.ticks1
		return time.time() - self.ticks1		
	def getMiliSeconds(self):
		return int(self.getSeconds() * 1000)
	def getMicroSeconds(self):
		return int(self.getSeconds() * 1000000)
	
class BenchMark:		
	def __init__(self,iterations):
		self.microSeconds = 0
		self.iterations = iterations

	def runOneIteration(self): 
		chronometer = Chronometer()							
		chronometer.start()				
		NumericSortTest().test()
		chronometer.stop()		
		self.microSeconds = self.microSeconds + chronometer.getMicroSeconds()		
		

	def run(self): 
		for i in range(self.iterations):
			self.runOneIteration()
		return self.microSeconds
		
if __name__ == '__main__':
	import sys
	if len(sys.argv) < 2: 
		print ("You must pass the number of thousands iterations.")
		sys.exit(-1)  
	iterations = int(sys.argv[1])
	bench = BenchMark(iterations)	
	print(str(int(bench.run())).replace(".",","))