function NumericSortTest() {  	
}

function getRandomInt(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}

NumericSortTest.prototype.NumSift = function(TestArray,min,max) {
	while ((min + min) <= max)
	{                
		var inc = false;
		if ((min + min) < max && TestArray[min + min] < TestArray[min + min + 1])
			inc = true;
		var k = inc ? min + min + 1 : min + min;                
		if (TestArray[min] < TestArray[k])
		{                   
			var temp = TestArray[k];
			TestArray[k] = TestArray[min];
			TestArray[min] = temp;                 
			min = k;                    
		}
		else
			min = max + 1;
	}		
}

NumericSortTest.prototype.JGFkernel = function(TestArray,array_rows) {
	var temp; 						
	var top = array_rows - 1;			
	var i = Math.floor(top / 2);
	while( i > 0)
	{								
		this.NumSift(TestArray,i, top);
		i = i - 1;
	}	
	i = top;
	while( i > 0)
	{
		this.NumSift(TestArray,0, i);
		temp = TestArray[0];
		TestArray[0] = TestArray[i];
		TestArray[i] = temp;
		i = i - 1;
	}			
}

NumericSortTest.prototype.JGFvalidate = function(TestArray,array_rows) {
	var error = false;
	var i = 1;
	while (i < array_rows)
	{
		error = (TestArray[i] < TestArray[i - 1]);				
		if (error)
		{
			print("Validation failed");
			print("Item " + i + " = " + TestArray[i]);
			print("Item " + (i - 1) + " = " + TestArray[i - 1]);					
			break;
		}
		i = i + 1;
	}	
}

NumericSortTest.prototype.test = function() {
	var size = 0;
	
	var datasizes = new Array(3);            
	datasizes[0] = 1000000;
	datasizes[1] = 5000000;
	datasizes[2] = 25000000; 
	
	var array_rows = datasizes[size];
	TestArray = new Array(array_rows);	
	var i = 0;
	while(i < array_rows)
	{
		TestArray[i] = getRandomInt(0,2147483647);		
		i = i + 1;
	}			
	
	this.JGFkernel(TestArray,array_rows);
	this.JGFvalidate(TestArray,array_rows);   	
}

function BenchMark(iterations) {
    this.microSeconds = 0;
	this.iterations = iterations;
}

BenchMark.prototype.runOneIteration = function() {		
	var before = new Date();
	new NumericSortTest().test();
	var after = new Date();	
	this.microSeconds =  this.microSeconds + ((after-before) * 1000);
}

BenchMark.prototype.run = function() {	
	for(var i = 0 ; i < this.iterations ; i++)
		this.runOneIteration();	
	return this.microSeconds;
}	

function range(n) {
	var result = new Array();
	for(var i=0; i<n; i++)
		result[i] = i;
	return result;
}

if (scriptArgs.length == 1) {		
	var bench = new BenchMark(scriptArgs[0]);
	print(bench.run());
}
else {
	print("I need the name of the test.");
	quit();
}